//=============================================================================
// Some SkaarjBerserker :|
//=============================================================================
class ExSkaarjBerserker expands SkaarjWarrior;

function bool ChooseTeamAttackFor(ScriptedPawn TeamMember)
{
	if ( TeamMember == None || !LineOfSightTo(TeamMember) || !LineOfSightTo(TeamMember.Enemy) || Health < 1)
		return false; //Bla, bla...
	if ( (Enemy == None) && (TeamMember.Enemy != None) && LineOfSightTo(TeamMember) )
	{
		if (SetEnemy(TeamMember.Enemy))
			MakeNoise(1.0);
	}

	// speak order
	if ( !bTeamSpeaking )
		SpeakOrderTo(TeamMember);
	
	// set CombatStyle and Aggressiveness of TeamMember
	if ( TeamMember == Self )
	{
		ChooseLeaderAttack();
		return true;
	}

	if ( TeamMember.bReadyToAttack )
	{
		////log("Attack!");
		TeamMember.Target = TeamMember.Enemy;
		If (VSize(Enemy.Location - Location) <= (TeamMember.MeleeRange + TeamMember.Enemy.CollisionRadius + TeamMember.CollisionRadius))
		{
			TeamMember.GotoState('MeleeAttack');
			return true;
		}
		else if (TeamMember.bMovingRangedAttack || (TeamMember.TeamID == 1) )
			TeamMember.SetTimer(TimeBetweenAttacks, False);
		else if (TeamMember.bHasRangedAttack && (TeamMember.bIsPlayer || TeamMember.Enemy.bIsPlayer) && TeamMember.CanFireAtEnemy() )
		{
			if ( !TeamMember.bIsPlayer || (3 * FRand() > Skill) )
			{
				TeamMember.GotoState('RangedAttack');
				return true;
			}
		}
	}

	if ( !TeamMember.bHasRangedAttack || (TeamMember.TeamID == 1) )
		TeamMember.GotoState('Charging');
	else if ( TeamMember.TeamID == 2 )
	{
		TeamMember.bStrafeDir = true;
		TeamMember.GotoState('TacticalMove', 'NoCharge'); 
	}
	else if ( TeamMember.TeamID == 3 )
	{
		TeamMember.bStrafeDir = false;
		TeamMember.GotoState('TacticalMove', 'NoCharge'); 
	}
	else
		TeamMember.GotoState('TacticalMove');

	return true;
}

function WhatToDoNext(name LikelyState, name LikelyLabel)
{
	local Pawn aPawn;

	if ( Health > 0 && !bDeleteMe )
	{
		aPawn = Level.PawnList;
		while ( aPawn != None && aPawn != self && aPawn.Health > 0)
		{
			if ( aPawn.IsA('PlayerPawn') || (aPawn.IsA('ScriptedPawn') && !aPawn.IsA('ExSkaarjBerserker') && !aPawn.IsA('Pupae'))
				&& (VSize(Location - aPawn.Location) < 500)
				&& CanSee(aPawn) && AttitudeTo(aPawn) == ATTITUDE_Hate )
			{
				if ( SetEnemy(aPawn) )
				{
					GotoState('Attacking');
					GoTo JL89;
				}
			}
			aPawn = aPawn.nextPawn;
		}
		Super(ScriptedPawn).WhatToDoNext(LikelyState, LikelyLabel);
	}
JL89:
}

function bool MeleeDamageTarget(int hitdamage, vector pushdir)
{
	local vector HitLocation, HitNormal, TargetPoint;
	local actor HitActor;

	// check if still in melee range
	// and if we have some
	if ( Target == None && (Enemy != None && Enemy.Health > 0 && Enemy != Self ) )
		Target = Enemy;
	if ( Target != None && Target != Self )
	{
		if ( (VSize(Target.Location - Location) <= MeleeRange * 1.4 + Target.CollisionRadius + CollisionRadius)
		&& ((Physics == PHYS_Flying) || (Physics == PHYS_Swimming) || (Abs(Location.Z - Target.Location.Z) 
			<= FMax(CollisionHeight, Target.CollisionHeight) + 0.5 * FMin(CollisionHeight, Target.CollisionHeight))) )
		{
			HitActor = Trace(HitLocation, HitNormal, Target.Location, Location, false);
			if ( HitActor != None )
				return false;
			Target.TakeDamage(hitdamage, Self,HitLocation, pushdir, 'hacked');
			return true;
		}
	}
	return false;
}

function SpinDamageTarget()
{
	if ( Target != None )
		if (MeleeDamageTarget(SpinDamage, (SpinDamage * 1000 * Normal(Target.Location - Location))) )
			PlaySound(slice, SLOT_Interact);
}

function ClawDamageTarget()
{
	if ( Target != None )
		if ( MeleeDamageTarget(ClawDamage, (ClawDamage * 900 * Normal(Target.Location - Location))) )
			PlaySound(slice, SLOT_Interact);
}

function eAttitude AttitudeToCreature(Pawn Other)
{
	if ( Other.IsA('ScriptedPawn') && !Other.IsA('ExSkaarjBerserker') && !Other.IsA('Pupae'))
		return ATTITUDE_Hate;
	else
		return Super(ScriptedPawn).AttitudeToCreature(Other);
}

defaultproperties
{
   LungeDamage=40
   SpinDamage=40
   ClawDamage=20
   VoicePitch=0.300000
   Aggressiveness=0.800000
   Health=320
   Skill=1.000000
   CombatStyle=0.800000
   Skin=Texture'UnrealI.Skins.Skaarjw2'
   DrawScale=1.200000
   Fatness=150
   CollisionHeight=60.000000
   Mass=180.000000
   Buoyancy=180.000000
   RotationRate=(Yaw=50000)
   MenuName="SkaarjBerserker"
   NameArticle=" a "
   bCollideActors=False
   bBlockActors=False
   bBlockPlayers=False
}
