//=============================================================================
// Squid. - Let me see what the heck is this
//=============================================================================
class ExSquid expands Squid;

function bool SetEnemy( Pawn NewEnemy )
{
	local bool result;
	local eAttitude newAttitude, oldAttitude;
	local bool noOldEnemy;
	local float newStrength;

/*
	if ( !bCanWalk && !bCanFly && !NewEnemy.FootRegion.Zone.bWaterZone )
		return false;
// Pretty dumb code for mapping options
*/
	if ( (NewEnemy == Self) || (NewEnemy == None) || (NewEnemy.Health <= 0) || NewEnemy.bDeleteMe )
		return false;
	if ( (/*PlayerPawn*/NewEnemy == None) && (ScriptedPawn(NewEnemy) == None) )
		return false;
	noOldEnemy = (Enemy == None);
	result = false;
	newAttitude = AttitudeTo(NewEnemy);
	//log ("Attitude to potential enemy is "$newAttitude);
	if ( !noOldEnemy )
	{
		if (Enemy == NewEnemy)
			return true;
		else if ( NewEnemy.bIsPlayer && NewEnemy.PlayerReplicationInfo != None && (AlarmTag != '') )
		{
			OldEnemy = Enemy;
			Enemy = NewEnemy;
			result = true;
		} 
		else if ( newAttitude == ATTITUDE_Friendly )
		{
			if ( bIgnoreFriends )
				return false;
			if ( (NewEnemy.Enemy != None) && (NewEnemy.Enemy.Health > 0) ) 
			{
				if ( NewEnemy.Enemy.bIsPlayer && NewEnemy.Enemy.PlayerReplicationInfo != None && (NewEnemy.AttitudeToPlayer < AttitudeToPlayer) )
					AttitudeToPlayer = NewEnemy.AttitudeToPlayer;
				if ( AttitudeTo(NewEnemy.Enemy) < AttitudeTo(Enemy) )
				{
					OldEnemy = Enemy;
					Enemy = NewEnemy.Enemy;
					result = true;
				}
			}
		}
		else 
		{
			oldAttitude = AttitudeTo(Enemy);
			if ( (newAttitude < oldAttitude) || 
				( (newAttitude == oldAttitude) 
					&& ((VSize(NewEnemy.Location - Location) < VSize(Enemy.Location - Location)) 
						|| !LineOfSightTo(Enemy)) ) ) 
			{
				if ( bIsPlayer && Enemy.PlayerReplicationInfo != None && NewEnemy.PlayerReplicationInfo == None )
				{
					newStrength = relativeStrength(NewEnemy);
					if ( (newStrength < 0.2) && (relativeStrength(Enemy) < FMin(0, newStrength))  
						&& (IsInState('Hunting')) && (Level.TimeSeconds - HuntStartTime < 5) )
						result = false;
					else
					{
						result = true;
						OldEnemy = Enemy;
						Enemy = NewEnemy;
					}
				} 
				else
				{
					result = true;
					OldEnemy = Enemy;
					Enemy = NewEnemy;
				}
			}
		}
	}
	else if ( newAttitude < ATTITUDE_Ignore )
	{
		result = true;
		Enemy = NewEnemy;
	}
	else if ( newAttitude == ATTITUDE_Friendly ) //your enemy is my enemy
	{
		//log("noticed a friend");
		if ( NewEnemy.bIsPlayer && NewEnemy.PlayerReplicationInfo != None && (AlarmTag != '') )
		{
			Enemy = NewEnemy;
			result = true;
		} 
		if (bIgnoreFriends)
			return false;

		if ( (NewEnemy.Enemy != None) && (NewEnemy.Enemy.Health > 0) ) 
		{
			result = true;
			//log("his enemy is my enemy");
			Enemy = NewEnemy.Enemy;
			if ( Enemy.bIsPlayer && Enemy.PlayerReplicationInfo != None )
				AttitudeToPlayer = ScriptedPawn(NewEnemy).AttitudeToPlayer;
			else if ( (ScriptedPawn(NewEnemy) != None) && (ScriptedPawn(NewEnemy).Hated == Enemy) )
				Hated = Enemy;
		}
	}
	if ( result )
	{
		//log(class$" has new enemy - "$enemy.class);
		LastSeenPos = Enemy.Location;
		LastSeeingPos = Location;
		EnemyAcquired();
		if ( !bFirstHatePlayer && Enemy.bIsPlayer && Enemy.PlayerReplicationInfo != None && (FirstHatePlayerEvent != '') )
			TriggerFirstHate();
	}
	else if ( NewEnemy.bIsPlayer && NewEnemy.PlayerReplicationInfo != None && (NewAttitude < ATTITUDE_Threaten) )
		OldEnemy = NewEnemy;

	return result;
}

function GrabTarget()
{
	if ( Target == None || Target.bDeleteMe || (Target.IsA('Pawn') && Pawn(Target).Health <= 0) ) //I don't need self check
		goto NoGrabNone;
	else
	{
		if ( MeleeDamageTarget(SlapDamage, (SlapDamage * 1500.0 * Normal(Location - Target.Location))) )
			PlaySound(SlapGrabHit, SLOT_Interact);
	}
NoGrabNone:
}

function SlapTarget()
{
	if ( Target == None || Target.bDeleteMe || (Target.IsA('Pawn') && Pawn(Target).Health <= 0) ) //I don't need self check
		goto NoSlapNone;
	else
	{
		if ( MeleeDamageTarget(SlapDamage, (SlapDamage * 1500.0 * Normal(Target.Location - Location))) )
			PlaySound(SlapGrabHit, SLOT_Interact);
	}
NoSlapNone:
}

function ThrustTarget()
{
	if ( Target == None || Target.bDeleteMe || (Target.IsA('Pawn') && Pawn(Target).Health <= 0) ) //I don't need self check
		goto NoThrustNone;
	else
	{
		if ( MeleeDamageTarget(ThrustDamage, (ThrustDamage * 1500.0 * Normal(Target.Location - Location))) )
			PlaySound(ThrustHit, SLOT_Interact);
	}
NoThrustNone:
}
	
//FIXME - hold (turn off client's physics???
// Whaaat !!????
function PlayMeleeAttack()
{
	local float decision;
	decision = FRand();
	if (decision < 0.35)
	{
		PlaySound(Thrust, SLOT_Interact);
		PlayAnim('Thrust', 0.8);
	}
	if (decision < 0.7)
	{
		PlaySound(Slap, SLOT_Interact);
		PlayAnim('Slap', 0.8);
	}
	else 
	{
		PlaySound(Grab, SLOT_Interact);
		PlayAnim('Grab'); 
 	}
}

function bool MeleeDamageTarget(int hitdamage, vector pushdir)
{
	local vector HitLocation, HitNormal, TargetPoint;
	local float TargetDist;
	local actor HitActor;
	local bool result;
	
	result = false;
	if ( Target == None && Enemy != None && Target != Self && Enemy != Self && Enemy.Health > 0 )
		Target = Enemy;
	if ( Target == None || ( Target != None && ( Target.bIsPawn && Pawn(Target).health <= 0 || Pawn(Target) == Self )) )
		return False;
	else
	{
		TargetDist = VSize(Target.Location - Location);
		Acceleration = AccelRate * (Target.Location - Location)/TargetDist;
		If (TargetDist <= (MeleeRange * 1.4 + Target.CollisionRadius + CollisionRadius)) //still in melee range
		{
			TargetPoint = Location - TargetDist * vector(Rotation); 
			TargetPoint.Z = FMin(TargetPoint.Z, Target.Location.Z + Target.CollisionHeight);
			TargetPoint.Z = FMax(TargetPoint.Z, Target.Location.Z - Target.CollisionHeight);
			HitActor = Trace(HitLocation, HitNormal, TargetPoint, Location, true);
			If (HitActor == Target)
			{
				Target.TakeDamage(hitdamage, Self,HitLocation, pushdir, 'hacked');
				result = true;
			}
		}
	}
	return result;
}

State Flopping
{
ignores seeplayer, hearnoise, enemynotvisible, hitwall; 	
	function Timer()
	{
		SetPhysics(PHYS_Falling);
		Velocity = 200 * VRand();
		Velocity.Z = 170 + 200 * FRand();
		DesiredRotation.Pitch = Rand(8192) - 4096;
		DesiredRotation.Yaw = Rand(65535);
	}
	
	function ZoneChange( ZoneInfo NewZone )
	{
		local Rotator newRotation;
		if (NewZone.bWaterZone)
		{
			newRotation = Rotation;
			newRotation.Roll = 0;
			SetRotation(newRotation);
			SetPhysics(PHYS_Swimming);
			GotoState('Attacking');
		}
		else if (Physics != PHYS_Falling)
			SetPhysics(PHYS_Falling);
	}
	
	function Landed(vector HitNormal)
	{
		SetPhysics(PHYS_None);
		DesiredRotation.Pitch = 0;
		SetTimer(0.3 + FRand(), false);
	}
	
	function AnimEnd()
	{
		PlayAnim('Spin', 0.7);
	}

Begin:
	SetTimer(0.3 + FRand(), false);
	TweenAnim('Flopping', 0.7);
}

state TacticalMove
{
ignores SeePlayer, HearNoise;

	function Timer()
	{
		Spawn(class'BigBlackSmoke');
	}
	
	function BeginState()
	{
		SetTimer(0.2, true);
		Super.BeginState();
	}
}

//squid has own melee attack because he faces away from his target when attacking
state MeleeAttack
{
ignores SeePlayer, HearNoise, Bump;
	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
							Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		if ( health <= 0 )
			GoTo JL290;
		if (NextState == 'TakeHit')
		{
			NextState = 'MeleeAttack';
			NextLabel = 'Begin';
		}
JL290:
	}

	function KeepAttacking()
	{
		bReadyToAttack = true;
		if ( /*(Target == None) //Craps removed
			||*/ ((Pawn(Target) != None) && (Pawn(Target).Health == 0)) )
			GotoState('Attacking');
		else if (VSize(Target.Location - Location) > (0.9 * MeleeRange + Target.CollisionRadius + CollisionRadius)) 
			GotoState('TacticalMove', 'NoCharge');
	}

	function EnemyNotVisible()
	{
		//log("enemy not visible");
		GotoState('Attacking');
	}

	function AnimEnd()
	{
		GotoState('MeleeAttack', 'DoneAttacking');
	}
	
	function BeginState()
	{
		Disable('AnimEnd');
		bCanStrafe = true; //so he can turn in place
	}

	function EndState()
	{
		bCanStrafe = false;
	}
	
Begin:
	if ( Target == None && Enemy != None ) //completed
		Target = Enemy;
FaceTarget:
	Acceleration = Vect(0,0,0);
	if ( Target != None )
	{
	if (NeedToTurn(2 * Location - Target.Location))
	{
		PlayTurning();
		TurnTo(2 * Location - Target.Location);
		TweenToFighter(0.15);
	}
	else if ( (5 - Skill) * FRand() > 3 ) 
	{
		DesiredRotation = Rotator(Location - Target.Location);
		PlayChallenge(); 
	}
	FinishAnim();
	}
	if ( Target != None ) //inserted check - will see
		if (VSize(Location - Target.Location) > MeleeRange + CollisionRadius + Target.CollisionRadius)
			GotoState('Attacking'); 
ReadyToAttack:
	DesiredRotation = Rotator(Location - Target.Location);
	PlayMeleeAttack();
	Enable('AnimEnd');
Attacking:
	TurnTo(2 * Location - Target.Location);
	Goto('Attacking');
DoneAttacking:
	Disable('AnimEnd');
	KeepAttacking();
	Goto('FaceTarget');
}

defaultproperties
{
     ThrustDamage=35
     SlapDamage=30
     Thrust=Sound'UnrealI.Squid.thrust1sq'
     slapgrabhit=Sound'UnrealI.Squid.hit1sq'
     thrusthit=Sound'UnrealI.Squid.hit1sq'
     Slap=Sound'UnrealI.Squid.slap1sq'
     Turn=Sound'UnrealI.Squid.turn1sq'
     Grab=Sound'UnrealI.Squid.grab1sq'
     Aggressiveness=0.800000
     MeleeRange=70.000000
     GroundSpeed=0.000000
     WaterSpeed=260.000000
     AirSpeed=0.000000
     SightRadius=2000.000000
     PeripheralVision=-0.500000
     Health=260
     Intelligence=BRAINS_REPTILE
     HitSound1=Sound'UnrealI.Squid.injur1sq'
     HitSound2=Sound'UnrealI.Squid.injur2sq'
     Die=Sound'UnrealI.Squid.death1sq'
     AmbientSound=Sound'UnrealI.Squid.amb1sq'
     DrawType=DT_Mesh
     Mesh=LodMesh'UnrealI.Squid1'
     CollisionRadius=40.000000
     CollisionHeight=60.000000
     Mass=200.000000
     Buoyancy=200.000000
     RotationRate=(Pitch=13000,Roll=13000)
     MenuName="Squid"
     NameArticle=" a "
     bCollideActors=False
     bBlockActors=False
     bBlockPlayers=False
}
