//=============================================================================
// ExWoodenBox
// And so on... Fixing until year 3000 :|
//=============================================================================
class ExWoodenBox expands WoodenBox;

function bool PlayerSee()
{
	local bool bResult;
	local PlayerPawn P;

	bResult = False;
	foreach VisibleCollidingActors(class 'PlayerPawn', P, 2000, Location )
	{
		if ( P != None && P.LineOfSightTo(Self))
		{
			bResult = True;
			break;
		}
	}
	return bResult;
}

singular function ZoneChange( ZoneInfo NewZone )
{
	local float splashsize;
	local actor splash;

	if( NewZone.bWaterZone )
	{
		if( bSplash && !Region.Zone.bWaterZone && Mass<=Buoyancy 
			&& ((Abs(Velocity.Z) < 100) || (Mass == 0)) && (FRand() < 0.05) && /* !PlayerCanSeeMe */ !PlayerSee() )
		{
			bSplash = false;
			SetPhysics(PHYS_None);
		}
		else if( !Region.Zone.bWaterZone && (Velocity.Z < -200) )
		{
			// Else play a splash.
			splashSize = FClamp(0.0001 * Mass * (250 - 0.5 * FMax(-600,Velocity.Z)), 1.0, 3.0 );
			if( NewZone.EntrySound != None )
				PlaySound(NewZone.EntrySound, SLOT_Interact, splashSize);
			if( NewZone.EntryActor != None )
			{
				splash = Spawn(NewZone.EntryActor); 
				if ( splash != None )
					splash.DrawScale = splashSize;
			}
		}
		bSplash = true;
	}
	else if( Region.Zone.bWaterZone && (Buoyancy > Mass) )
	{
		bBobbing = true;
		if( Buoyancy > 1.1 * Mass )
			Buoyancy = 0.95 * Buoyancy; // waterlog
		else if( Buoyancy > 1.03 * Mass )
			Buoyancy = 0.99 * Buoyancy;
	}

	if( NewZone.bPainZone && (NewZone.DamagePerSec > 0) )
		TakeDamage(100, None, location, vect(0,0,0), NewZone.DamageType);
}

simulated function skinnedFrag(class<fragment> FragType, texture FragSkin, vector Momentum, float DSize, int NumFrags) 
{
	local int i;
	local actor A, Toucher;
	local Fragment s;

	if ( bOnlyTriggerable )
		GoTo JL92; 
	if (Event!='')
		foreach AllActors( class 'Actor', A, Event )
			A.Trigger( Toucher, pawn(Toucher) );
	if ( Region.Zone.bDestructive )
	{
		Destroy();
		GoTo JL92;
	}
	for (i=0 ; i<NumFrags ; i++) 
	{
		s = Spawn( FragType, Owner); //Attempt to SPAWN, read again, ATTEMPT...
		if ( s != None ) //As I know so far is possible to not spawn, especially if player is there or any pawn
		{				//because I don't recall to see player or other pawn telefragged by a decoration :|
			s.CalcVelocity(Momentum/100,0);
			s.Skin = FragSkin;
			s.DrawScale = DSize*0.5+0.7*DSize*FRand();
		}
	}
	Destroy();
JL92:
}

simulated function Frag(class<fragment> FragType, vector Momentum, float DSize, int NumFrags) 
{
	local int i;
	local actor A, Toucher;
	local Fragment s;

	if ( bOnlyTriggerable )
		GoTo JL121; 
	if (Event!='')
		foreach AllActors( class 'Actor', A, Event )
			A.Trigger( Toucher, pawn(Toucher) );
	if ( Region.Zone.bDestructive )
	{
		Destroy();
		GoTo JL121;
	}
	for (i=0 ; i<NumFrags ; i++) 
	{
		s = Spawn( FragType, Owner);
		if (s != None)		//The same shit as in previous case
		{
			s.CalcVelocity(Momentum,0);
			s.DrawScale = DSize*0.5+0.7*DSize*FRand();
		}
	}
	Destroy();
JL121:
}

function Destroyed()
{
	local actor dropped, A;
	local class<actor> tempClass;

	if( (Pawn(Base) != None) && (Pawn(Base).CarriedDecoration == self) )
		Pawn(Base).DropDecoration();
	if( (Contents!=None) && !Level.bStartup )
	{
		tempClass = Contents;
		if (Content2!=None && FRand()<0.3) tempClass = Content2;	//What if random is higher ?
		if (Content3!=None && FRand()<0.3) tempClass = Content3;	//Will see 0 contents if is only 2 or 3 ? 
		if (tempClass != None)							//Only if was randomly assigned !!! Next time I'll throw shit random in WC.
			dropped = Spawn(tempClass);
		if (dropped != None)							//Only if exists any !!! In hopping that you solved this in new engines...
		{
			dropped.RemoteRole = ROLE_DumbProxy;
			dropped.SetPhysics(PHYS_Falling);
			dropped.bCollideWorld = true;
			if ( inventory(dropped) != None )
				inventory(dropped).GotoState('Pickup', 'Dropped');
		}
	}

	if( Event != '' )
		foreach AllActors( class 'Actor', A, Event )
			A.Trigger( Self, None );

	if ( bPushSoundPlaying )
		PlaySound(EndPushSound, SLOT_Misc,0.0);

	Super(Actor).Destroyed();
}

defaultproperties
{
   Health=20
   FragChunks=12
   Fragsize=1.750000
   bPushable=True
   PushSound=Sound'UnrealShare.General.ObjectPush'
   EndPushSound=Sound'UnrealShare.General.Endpush'
   bStatic=False
   DrawType=DT_Mesh
   Mesh=LodMesh'UnrealShare.WoodenBoxM'
   CollisionRadius=29.000000
   CollisionHeight=26.000000
   bCollideWorld=True
   Mass=50.000000
   bCollideActors=False
   bBlockActors=False
   bBlockPlayers=False
}
