// ============================================================
// LightNotify
// ============================================================

class LightNotify expands SpawnNotify;

var bool bDoNotScrew;

function prebeginplay(); //don't check for relevance

/*
replication
{
	reliable if(Role == Role_Authority)
		bDoNotScrew;
}
*/

simulated function PostBeginPlay()
{
	local actor other;

	//Don't add to notifylist if server, but keep available, so it's existence is replicated to clients
	if (Level.NetMode == NM_DedicatedServer) //mutator works on server. We keep moving in client
		GoTo JL75;
	Super.PostBeginPlay(); //add.
	log ("Light Notify Initialized...");
//	ConsoleCommand("SET DISTANCELIGHTNING BSTATIC FALSE");
//	ConsoleCommand("SET DISTANCELIGHTNING BNODELETE FALSE");
//	ConsoleCommand("SET DISTANCELIGHTNING BGAMERELEVANT FALSE");
	ForEach Allactors(class'actor',other)
	{
		switch(Other.Class)
		{
			case Class 'DistanceLightning':
//				log ( Self.Name@" >> bDoNotScrew ="@bDoNotScrew );
				if ( !bDoNotScrew )
				{
					Other.bAlwaysRelevant=True; //Update if needs?
					Other.DrawType=DT_Mesh;
					Other.Mesh=LodMesh'UnrealShare.CandleM';
					Other.LightBrightness = 0;
					Other.LightHue = 0;
					Other.LightSaturation = 0;
					Other.LightRadius = 0;
					Other.LightPeriod = 0;
					Other.LightPhase = 0;
					Other.LightCone = 0;
					Other.VolumeBrightness = 0;
					Other.LightType = LT_None;
					Other.LightEffect = LE_None;
					Other.RemoteRole = ROLE_DumbProxy;
					Other.NetUpdateFrequency = 2.000000;
					Other.SetPhysics(PHYS_Falling); //Sent it in drainage pipe - it's jerky but I do this way.
					Other.Disable('Timer');
				}
				break;

			case Class 'Lamp1':
				if (Other.AmbientGlow < 245 && Other.Mesh == Other.Class.Default.Mesh)
					Other.AmbientGlow = 245;
				break;

			case Class 'Lamp4':
				if (Other.AmbientGlow < 245 && Other.Mesh == Other.Class.Default.Mesh)
					Other.AmbientGlow = 245;
				break;

			case Class 'Lantern':
				if (Other.AmbientGlow < 245 && Other.Mesh == Other.Class.Default.Mesh)
					Other.AmbientGlow = 245;
				break;

			case Class 'Lantern2':
				if (Other.AmbientGlow < 245 && Other.Mesh == Other.Class.Default.Mesh)
					Other.AmbientGlow = 245;
				break;

			case Class 'TubeLight':
				if (Other.AmbientGlow < 245 && Other.Mesh == Other.Class.Default.Mesh)
					Other.AmbientGlow = 245;
				break;

			case Class 'TubeLight2':
				if (Other.AmbientGlow < 245 && Other.Mesh == Other.Class.Default.Mesh)
					Other.AmbientGlow = 245;
				break;
		}
	}
JL75:
}

defaultproperties
{
}
