//=============================================================================
// MCHSpectator.
//=============================================================================
class MCHSpectator expands CHSpectator;

exec function Jump( optional float F )
{
	ViewClass(class'SpectatorCam', true);
	While ( (ViewTarget != None) && ViewTarget.IsA('SpectatorCam') && SpectatorCam(ViewTarget).bSkipView )
		ViewClass(class'SpectatorCam', true);
	if ( ViewTarget != None && ViewTarget.IsA('SpectatorCam') )
		bBehindView = false;
}

exec function ViewPlayerNum(optional int num)
{
	local Pawn P;

	if ( !PlayerReplicationInfo.bIsSpectator && !Level.Game.bTeamGame )
		GoTo JL57;
	if ( num >= 0 )
	{
		P = Pawn(ViewTarget);
		if ( (P != None) && P.bIsPlayer && (P.PlayerReplicationInfo.TeamID == num) )
		{
			ViewTarget = None;
			bBehindView = false;
			GoTo JL57;
		}
		for ( P=Level.PawnList; P!=None; P=P.NextPawn )
			if ( P != None && P.PlayerReplicationInfo != None
				&& (P.PlayerReplicationInfo.Team == PlayerReplicationInfo.Team)
				&& !P.PlayerReplicationInfo.bIsSpectator
				&& (P.PlayerReplicationInfo.TeamID == num) )
			{
				if ( P != self )
				{
					ViewTarget = P;
					bBehindView = true;
				}
				GoTo JL57;
			}
		GoTo JL57;
	}
	if ( Role == ROLE_Authority )
	{
		ViewClass(class'Pawn', true);
		While ( (ViewTarget != None) && Pawn(ViewTarget) != None
				&& ( Pawn(ViewTarget).PlayerReplicationInfo == None || Pawn(ViewTarget).PlayerReplicationInfo.bIsSpectator ) )
			ViewClass(class'Pawn', true);

		if ( ViewTarget != None && Pawn(ViewTarget) != None && Pawn(ViewTarget).PlayerReplicationInfo != None )
			ClientMessage(ViewingFrom@Pawn(ViewTarget).PlayerReplicationInfo.PlayerName, 'Event', true);
		else
			ClientMessage(ViewingFrom@OwnCamera, 'Event', true);
	}
JL57:
}

defaultproperties
{
}
