class MHBigBiogel expands BigBioGel;

function DropDrip()
{
	local BioDrop Gel;

	if (Level.NetMode != NM_DedicatedServer)
		PlaySound(SpawnSound);	// Dripping Sound
	Gel = Spawn(class'MHBioDrop',,,Location-Vect(0,0,1)*10);
	if (Gel != None)
		Gel.DrawScale = DrawScale * 0.5;
}

simulated function SetWall(vector HitNormal, Actor Wall)
{
	local vector TraceNorm, TraceLoc, Extent;
	local actor HitActor;
	local rotator RandRot;

	SurfaceNormal = HitNormal;
	RandRot = rotator(HitNormal);
	RandRot.Roll += 32768;
	SetRotation(RandRot);
	if ( Mover(Wall) != None )
		SetBase(Wall);
	if ( Level.NetMode != NM_DedicatedServer )
	{
		class'Biomark'.Default.DrawScale = DrawScale * 0.65;
		spawn(class'BioMark',,,Location, rotator(SurfaceNormal));
		class'Biomark'.Default.DrawScale = 0.65;
	}
}

auto state Flying
{
	simulated function HitWall( vector HitNormal, actor Wall )
	{
		SetPhysics(PHYS_None);
		if ( ROLE == ROLE_Authority )
			MakeNoise(0.6);
		bOnGround = True;
		if (Level.NetMode != NM_DedicatedServer)
			PlaySound(ImpactSound);
		SetWall(HitNormal, Wall);
		DrawScale=DrawScale*1.4;
		GoToState('OnSurface');
	}

	simulated function BeginState()
	{
		local Vector viewDir;

		viewDir = vector(Rotation);
		if ( Instigator != None )
			Velocity = (Speed + (viewDir dot Instigator.Velocity)) * viewDir;
		else
			Velocity = Speed * viewDir;
		Velocity.z += 120;
		if ( Level.NetMode != NM_DedicatedServer )
		{
			RandSpin(100000);
			PlaySound(SpawnSound);
		}
		LoopAnim('Flying',0.4);
		bOnGround=False;
		if( Region.zone.bWaterZone )
			Velocity=Velocity*0.7;
	}
}

state OnSurface
{
	simulated function BeginState()
	{
		wallTime = DrawScale*5+2;

		if ( Mover(Base) != None )
		{
			BaseOffset = VSize(Location - Base.Location);
			SetTimer(0.2, true);
		}
		else 
			SetTimer(wallTime, false);
	}
}

defaultproperties
{
     speed=700.000000
     Damage=75.000000
     MomentumTransfer=30000
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=25.000000
     CollisionRadius=3.000000
     CollisionHeight=4.000000
}
