class MHBioGel expands BioGel;

//#exec MESH NOTIFY MESH=BioRGel SEQ=Drip TIME=0.6 FUNCTION=DropDrip

var vector SurfaceNormal;
var bool bOnGround;
var bool bCheckedSurface;
var int numBio;
var float wallTime;
var float BaseOffset;

simulated function PostBeginPlay()
{
//	SetTimer(3.0, false);
	Super.PostbeginPlay(); //Now start timer in parent
}

function Timer()
{
	local GreenGelPuff f;

	if ( bDeleteMe ) GoTo JL37;
	f = spawn(class'GreenGelPuff',,,Location + SurfaceNormal*8); 
	if (f != None)
	{
		f.DrawScale = DrawScale*2.0;
		f.numBlobs = numBio;
		if ( numBio > 0 )
		f.SurfaceNormal = SurfaceNormal;
	}
	PlaySound (MiscSound,,6.0*DrawScale);
	if ( (Mover(Base) != None) && Mover(Base).bDamageTriggered )
		Base.TakeDamage( Damage, instigator, Location, MomentumTransfer * Normal(Velocity), '');
	HurtRadius(damage * Drawscale, DrawScale * 120, 'corroded', MomentumTransfer * Drawscale, Location);
	MakeNoise(0.4);
	Destroy();
JL37:
}

simulated function SetWall(vector HitNormal, Actor Wall)
{
	local vector TraceNorm, TraceLoc, Extent;
	local actor HitActor;
	local rotator RandRot;
	local BioMark bm;

	SurfaceNormal = HitNormal;
	RandRot = rotator(HitNormal);
	RandRot.Roll += 32768;
	SetRotation(RandRot);
	if ( Mover(Wall) != None )
		SetBase(Wall);
	if ( Level.NetMode != NM_DedicatedServer )
	{
		class'Biomark'.Default.DrawScale = DrawScale * 0.65;
		spawn(class'BioMark',,,Location, rotator(SurfaceNormal));
		class'Biomark'.Default.DrawScale = 0.65;
	}
}

singular function TakeDamage( int NDamage, Pawn instigatedBy, Vector hitlocation, 
						vector momentum, name damageType )
{
	if ( damageType == 'Corroded' )
		numBio = 3;
	GoToState('Exploding');
}

auto state Flying
{
	simulated function ProcessTouch (Actor Other, vector HitLocation) 
	{ 
		if ( Pawn(Other)!=Instigator || bOnGround) 
			Global.Timer(); 
	}

	simulated function HitWall( vector HitNormal, actor Wall )
	{
		SetPhysics(PHYS_None);
		if ( ROLE == ROLE_Authority )
			MakeNoise(0.3);
		bOnGround = True;
		if (Level.NetMode != NM_DedicatedServer)
			PlaySound(ImpactSound);
		SetWall(HitNormal, Wall);
		PlayAnim('Hit');
		GoToState('OnSurface');
	}

	simulated function ZoneChange( Zoneinfo NewZone )
	{
		local waterring w;

		if (!NewZone.bWaterZone) Return;

		if (!bOnGround) 
		{
			w = Spawn(class'WaterRing',,,,rot(16384,0,0));
			if (w != None)
			w.DrawScale = 0.1;
		}
		bOnGround = True;
		Velocity=0.1*Velocity;
	}

	function Timer()
	{
		GotoState('Exploding');
	}

	simulated function BeginState()
	{
		if ( Role == ROLE_Authority )
		{
			Velocity = Vector(Rotation) * Speed;
			Velocity.z += 120;
			if( Region.zone.bWaterZone )
				Velocity=Velocity*0.7;
		}
		if ( Level.NetMode != NM_DedicatedServer )
		{
			RandSpin(100000);
			PlaySound(SpawnSound);
		}
		LoopAnim('Flying',0.4);
		bOnGround=False;
	}
}

state OnSurface
{
	function ProcessTouch (Actor Other, vector HitLocation)
	{
		GotoState('Exploding');
	}

	simulated function CheckSurface()
	{
		local float DotProduct;

		DotProduct = SurfaceNormal dot vect(0,0,-1);
		if( DotProduct > 0.7 )
			PlayAnim('Drip',0.1);
		else if (DotProduct > -0.5 && DotProduct <= 0.7 )
			PlayAnim('Slide',0.2);
	}

	function Timer()
	{
		if ( Mover(Base) != None )
		{
			WallTime -= 0.2;
			if ( WallTime < 0.15 )
				Global.Timer();
			else if ( VSize(Location - Base.Location) > BaseOffset + 4 )
				Global.Timer();
		}
		else
			Global.Timer();
	}

	function BeginState()
	{
		wallTime = DrawScale*3+1;

		if ( Mover(Base) != None )
		{
			BaseOffset = VSize(Location - Base.Location);
			SetTimer(0.2, true);
		}
		else 
			SetTimer(wallTime, false);
	}

	function AnimEnd()
	{
		if ( !bCheckedSurface && (DrawScale > 1.0) )
			CheckSurface();
		bCheckedSurface = true;
	}

}

defaultproperties
{
   numBio=7
   speed=800.000000
   MaxSpeed=1500.000000
   Damage=40.000000
   MomentumTransfer=20000
   ImpactSound=Sound'UnrealShare.BioRifle.GelHit'
   MiscSound=Sound'UnrealShare.General.Explg02'
   bNetTemporary=False
   Physics=PHYS_Falling
   RemoteRole=ROLE_SimulatedProxy
   LifeSpan=12.000000
   AnimSequence=Flying
   Mesh=LodMesh'UnrealShare.BioRGel'
   bUnlit=True
   CollisionRadius=2.000000
   CollisionHeight=2.000000
   bProjTarget=True
   LightType=LT_Steady
   LightEffect=LE_NonIncidence
   LightBrightness=70
   LightHue=91
   LightRadius=3
   bBounce=True
   Buoyancy=170.000000
}
