//=============================================================================
// RingExplosion. MH version
//=============================================================================
class MHRingExplosion expands RingExplosion;

var bool bExtraEffectsSpawned;

simulated function Tick( float DeltaTime )
{
	if ( Level.NetMode != NM_DedicatedServer )
	{
		ScaleGlow = (Lifespan/Default.Lifespan);
		AmbientGlow = ScaleGlow * 255;
	}
	if ( !bExtraEffectsSpawned )
	{
		if ( Level.NetMode != NM_DedicatedServer )
			SpawnExtraEffects();
		bExtraEffectsSpawned = True;
	}
}

simulated function PostBeginPlay()
{
	if ( Level.NetMode != NM_DedicatedServer )
	{
		PlayAnim( 'Explosion', 0.25 );
		SpawnEffects();
//		log (Self$" Explosion 1...");
	}
	if ( Instigator != None )
		MakeNoise(0.5);
}

simulated function SpawnEffects()
{
	local actor a;

	a = Spawn(class'EffectLight');
	if (a != None)
		a.RemoteRole = ROLE_None;
	a = Spawn(class'ParticleBurst2');
	if (a != None)
		a.RemoteRole = ROLE_None;
}

simulated function SpawnExtraEffects()
{
	Spawn(class'BotPack.EnergyImpact');
}

defaultproperties
{
     ExploSound=Sound'UnrealShare.General.Expl03'
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=0.800000
     DrawType=DT_Mesh
     Style=STY_None
     Mesh=LodMesh'UnrealShare.Ringex'
     DrawScale=0.700000
     ScaleGlow=1.100000
     bUnlit=True
}
