class MHRocket expands Projectile;

var float MagnitudeVel,Count,SmokeRate;
var bool bRing,bHitWater,bWaterStart;
var int NumExtraRockets;
var vector InitialDir;
var	rockettrail trail;

simulated function Destroyed()
{
	if ( Trail != None )
		Trail.Destroy();
	Super.Destroyed();
}
/*
simulated function PostBeginPlay()
{
//	Trail = Spawn(class'RocketTrail',self);
	Count = -0.1;
	if (Level.bHighDetailMode) SmokeRate = 0.035;
	else SmokeRate = 0.15;
}
*/
simulated function PostBeginPlay()
{
//	Trail = Spawn(class'RocketTrail',self);
	if ( Level.bHighDetailMode )
	{
		SmokeRate = (20 + (0.5 + 2 * FRand()) * NumExtraRockets * 24)/Speed; 
		if ( Level.bDropDetail )
		{
			SoundRadius = 6;
			LightRadius = 3;
		}
	}
	else 
	{
		SmokeRate = 0.08 + FRand()*(0.02+NumExtraRockets);
		LightRadius = 3;
	}
	SetTimer(SmokeRate, true);
}

simulated function Timer()
{
	local SpriteSmokePuff b;

	if ( Region.Zone.bWaterZone || (Level.NetMode == NM_DedicatedServer) )
		GoTo JL70;

	if ( Level.bHighDetailMode )
	{
		if ( Level.bDropDetail || ((NumExtraRockets > 0) && (FRand() < 0.5)) )
			Spawn(class'LightSmokeTrail');
		else
			Spawn(class'UTSmokeTrail');
		SmokeRate = 152/Speed; 
	}
	else 
	{
		SmokeRate = 0.15 + FRand()*(0.01+NumExtraRockets);
		if ( Level.NetMode != NM_DedicatedServer )
		{
			b = Spawn(class'SpriteSmokePuff');
			if ( b != None )
				b.RemoteRole = ROLE_None;
		}
	}
	SetTimer(SmokeRate, false);
JL70:
}

auto state Flying
{

	simulated function ZoneChange( Zoneinfo NewZone )
	{
		local waterring w;
		
		if (!NewZone.bWaterZone || bHitWater) Return;

		bHitWater = True;
		if ( Level.NetMode != NM_DedicatedServer )
		{
			w = Spawn(class'WaterRing',,,,rot(16384,0,0));
			if (w != None)
			{
				w.DrawScale = 0.2;
				w.RemoteRole = ROLE_None;
			}
			PlayAnim( 'Still', 3.0 );
		}
		Velocity=0.6*Velocity;
	}

	simulated function ProcessTouch (Actor Other, Vector HitLocation)
	{
		if ( (Other != instigator) && !Other.IsA('Projectile') ) 
			Explode(HitLocation,Normal(HitLocation-Other.Location));
	}

	function BlowUp(vector HitLocation)
	{
		if ( Level.Game.IsA('DeathMatchGame') ) //bigger damage radius
			HurtRadius(0.9 * Damage,240.0, 'exploded', MomentumTransfer, HitLocation );
		else
			HurtRadius(Damage,200.0, 'exploded', MomentumTransfer, HitLocation );
		MakeNoise(1.0);
	}

	simulated function Explode(vector HitLocation, vector HitNormal)
	{
		local MHSpriteBallExplosion s;

		if (!bDeleteMe)
		{
			if (Level.NetMode != NM_DedicatedServer)
			{
				s = spawn(class'MHSpriteBallExplosion',,,HitLocation + HitNormal*16);
				if (s != None)
					s.RemoteRole = ROLE_None;
			}
			if ( ROLE == ROLE_Authority )
				BlowUp(HitLocation);
			Destroy();
		}
	}
	simulated function BeginState()
	{
		initialDir = vector(Rotation);
//		if ( Role == ROLE_Authority )
		Velocity = speed*initialDir;
		Acceleration = initialDir*50;
		if ( Level.NetMode != NM_DedicatedServer )
		{
			PlaySound(SpawnSound, SLOT_None, 2.3);
			PlayAnim( 'Armed', 0.2 );
		}
		if (Region.Zone.bWaterZone)
		{
			bHitWater = True;
			Velocity=0.6*Velocity;
		}
	}
}

defaultproperties
{
   speed=900.000000
   MaxSpeed=1600.000000
   Damage=85.000000
   MomentumTransfer=80000
   SpawnSound=Sound'UnrealShare.Eightball.Ignite'
   ImpactSound=Sound'UnrealShare.Eightball.GrenadeFloor'
   RemoteRole=ROLE_SimulatedProxy
   LifeSpan=6.000000
   AnimSequence=Armed
   AmbientSound=Sound'UnrealShare.General.Brufly1'
   Skin=FireTexture'UnrealShare.Effect16.fireeffect16'
   Mesh=LodMesh'UnrealShare.RocketM'
   DrawScale=0.050000
   AmbientGlow=96
   bUnlit=True
   SoundRadius=9
   SoundVolume=255
   LightType=LT_Steady
   LightEffect=LE_NonIncidence
   LightBrightness=126
   LightHue=28
   LightSaturation=64
   LightRadius=6
   bCorona=True
   bBounce=True
   ExplosionDecal=Class'Botpack.BlastMark';
}
