class MHStingerProjectile expands StingerProjectile;

auto state Flying
{
	simulated function ProcessTouch( Actor Other, Vector HitLocation )
	{
		local int hitdamage;
		local vector hitDir;
		if ( !bDeleteMe )
		{
			if ( Other != Instigator )
			{
				if ( Role == ROLE_Authority )
				{
					hitDir = Normal(Velocity);
					if ( FRand() < 0.2 )
						hitDir *= 5;
					Other.TakeDamage(damage, instigator,HitLocation,
						(MomentumTransfer * hitDir), 'shot');
					MakeNoise(0.3);
				}
				Destroy();
			}
		}
	}

	simulated function HitWall( vector HitNormal, actor Wall )
	{
		Super.HitWall(HitNormal, Wall);

		if ( FRand() < 0.3 )
		{
			if ( Level.NetMode != NM_DedicatedServer )
				PlaySound(ImpactSound, SLOT_Misc, 0.5,,, 0.5+FRand());
		}
		else
		{
			if ( Level.NetMode != NM_DedicatedServer )
				PlaySound(MiscSound, SLOT_Misc, 0.6,,,1.0);
		}
		if (ROLE == ROLE_Authority)
			MakeNoise(0.3);
		SetPhysics(PHYS_None);
		SetCollision(false,false,false);
		RemoteRole = ROLE_None;
		Mesh = mesh 'Burst';
		SetRotation( RotRand() );
		PlayAnim ( 'Explo', 0.9 );
	}

	simulated function Timer()
	{
		local bubble1 b;

		if (Level.NetMode!=NM_DedicatedServer)
		{
	 		b=spawn(class'Bubble1'); 
			if (b != None)
			{
				b.DrawScale= 0.1 + FRand()*0.2;
				b.SetLocation(Location+FRand()*vect(2,0,0)+FRand()*Vect(0,2,0)+FRand()*Vect(0,0,2));
				b.buoyancy = b.mass+(FRand()*0.4+0.1);
			}
 		}
		DelayTime+=FRand()*0.1+0.1;
		SetTimer(DelayTime,False); 
	}

	simulated function ZoneChange( Zoneinfo NewZone )
	{
		if (NewZone.bWaterZone) 
		{
			Velocity=0.7*Velocity;
			DelayTime=0.03;
			SetTimer(DelayTime,False);
		}
	}

	simulated function BeginState()
	{
		local rotator RandRot;

		Velocity = Vector(Rotation) * speed;
		RandRot.Pitch = FRand() * 200 - 100;
		RandRot.Yaw = FRand() * 200 - 100;
		RandRot.Roll = FRand() * 200 - 100;
		Velocity = Velocity >> RandRot;
		if( Region.zone.bWaterZone )
			Velocity=0.7*Velocity;
	}
}

defaultproperties
{
     ExplosionDecal=Class'Botpack.WallCrack'
     Damage=20.000000
}