class MHTazerProj expands TazerProj;

var bool bRingDone, bAmped;

simulated function SuperExplosion()
{
	local RingExplosion r;
	local OSSpriteBallExplosion f;

	if ( !bDeleteMe )
	{
		if ( Role == ROLE_Authority )
			HurtRadius(Damage*3.9, 240, 'jolted', MomentumTransfer*2, Location );
		if (!bRingDone)
		{
			r = Spawn(Class'MHRingExplosion2',,'',Location,Instigator.ViewRotation);
			if ( bAmped )
			{
//				log (Self$" Big Combo");
				f = Spawn(Class'OSSpriteBallExplosion',,'',Location,Instigator.ViewRotation);
				if ( f != None )
					f.DrawScale=7.0;
			}
			bRingDone=True;
		}
		Destroy();
	}
}

simulated function HitWall (vector HitNormal, actor Wall)
{
	if (!bDeleteMe)
	{
		if ( Role == ROLE_Authority )
		{
			if ( (Mover(Wall) != None) && Mover(Wall).bDamageTriggered )
				Wall.TakeDamage( Damage, instigator, Location, MomentumTransfer * Normal(Velocity), '');
			MakeNoise(1.0);
		}
		Explode(Location + ExploWallOut * HitNormal, HitNormal);
		bRingDone=True;
	}
/*	if ( (ExplosionDecal != None) && (Level.NetMode != NM_DedicatedServer) )
		Spawn(ExplosionDecal,self,,Location, rotator(HitNormal));
*/
}

auto state Flying
{
	simulated function ProcessTouch (Actor Other, vector HitLocation)
	{
		if (!bDeleteMe)
		{
			if ( Other != Instigator )
			{
				Explode(HitLocation,Normal(HitLocation-Other.Location));
			}
		}
	}

	simulated function BeginState()
	{
		Velocity = vector(Rotation) * speed;
	}
}

simulated function Explode(vector HitLocation,vector HitNormal)
{
	local RingExplosion r;

	if ( !bDeleteMe )
	{
		if ( ROLE == ROLE_Authority )
		{
			if (Instigator == None || Instigator.health <= 0)
				bReplicateInstigator = False;
			HurtRadius(Damage, 70, 'jolted', MomentumTransfer, Location );
		}
		if ( Level.NetMode != NM_DedicatedServer )
			PlaySound(ImpactSound, SLOT_Misc, 0.5,,, 0.5+FRand());
		if ( !bRingDone )
		{
			if ( ROLE == ROLE_Authority )
			if ( Damage > 60 )
			{
				r = Spawn(class'MHRingExplosion3',,, HitLocation+HitNormal*8,rotator(HitNormal));
				bRingDone=True;
			}
			else
			{
				r = Spawn(class'MHRingExplosion',,, HitLocation+HitNormal*8,rotator(HitNormal));
				bRingDone=True;
			}
			if ( r != None )
			{
				if ( Level.NetMode != NM_DedicatedServer )
					r.PlaySound(r.ExploSound,,6);
			}
		}
		Destroy();
	}
}

defaultproperties
{
}
