//=============================================================================
// MHTeamCannon.
//=============================================================================
class MHTeamCannon expands TeamCannon; //Keep this family

function TakeDamage( int NDamage, Pawn instigatedBy, Vector hitlocation, 
					Vector momentum, name damageType)
{
	MakeNoise(1.0);
	Health -= NDamage;
	if (Health <0) 
	{
		PlaySound(DeActivateSound, SLOT_None,5.0);
		NextState = 'Idle';
		Enemy = None;
		Spawn(class'UT_BlackSmoke');
		GotoState('DamagedState');
	}
	else if ( instigatedBy == None || InstigatedBy.IsA('TeamCannon') )
		GoTo JL34;
	else if ( (Enemy == None) && (!instigatedBy.bIsPlayer || !Level.Game.bTeamGame || !SameTeamAs(instigatedBy.PlayerReplicationInfo.Team)) )
	{
		Enemy = instigatedBy;
//////////////// MH Needs 1) accidental damaged by Monster
		if (InstigatedBy.IsA('ScriptedPawn'))
		{
			ScriptedPawn(InstigatedBy).Hated=Self;
			ScriptedPawn(InstigatedBy).Enemy=Self;
			//Should be enough
		}
///////////////
		GotoState('ActiveCannon'); //Start firing
	}
JL34:
}

function Trigger( actor Other, pawn EventInstigator )
{
	if ( EventInstigator.bHidden || EventInstigator.health < 1 || EventInstigator == Self || EventInstigator == None )
		GoTo JL51;
	if (EventInstigator.PlayerReplicationInfo != None && EventInstigator.bIsPlayer)
		GotoState('DeActivated');
	else //This must be tested properly
	{
		if ( EventInstigator.PlayerReplicationInfo == None && !EventInstigator.IsA('StationaryPawn'))
		{
			Enemy = EventInstigator;
			GotoState('ActiveCannon');
		}
	}
JL51:
}

function Shoot()
{
	local Vector FireSpot, ProjStart;
	local Projectile p;

	if ( Target != None ) //Exist something or you fire in mountains ?
	{
	if (DesiredRotation.Pitch < -20000) GoTo JL81;
	PlaySound(FireSound, SLOT_None,5.0);
	PlayAnim(PickAnim());

	ProjStart = Location+Vector(DesiredRotation)*100 - Vect(0,0,1)*Drop;
	if ( bLeadTarget )
	{
		FireSpot = Target.Location + FMin(1, 0.7 + 0.6 * FRand()) * (Target.Velocity * VSize(Target.Location - ProjStart)/ProjectileType.Default.Speed);
		if ( !FastTrace(FireSpot, ProjStart) )
			FireSpot = 0.5 * (FireSpot + Target.Location);
		DesiredRotation = Rotator(FireSpot - ProjStart);
	}
	p = Spawn (ProjectileType,,,ProjStart,DesiredRotation);
	if ( DeathMatchPlus(Level.Game).bNoviceMode )
		P.Damage *= (0.4 + 0.15 * Level.game.Difficulty);
	if ( Target.IsA('WarShell') && Target != None )
		p.speed *= 2;
	bShoot=False;
	SetTimer(0.05,True);
	}
JL81:
}

auto state Idle
{
	ignores EnemyNotVisible;

	function SeePlayer(Actor SeenPlayer) //Monsters somehow aren't cute if are already around - bStasis ? Engine things ?
	{									//I think is a need for other method
		if ( SeenPlayer.bCollideActors 
			&& (Pawn(SeenPlayer).PlayerReplicationInfo != None && (Pawn(SeenPlayer).PlayerReplicationInfo.Team != MyTeam && MyTeam > 0)
			|| !Level.Game.bTeamGame || ( MyTeam == 0 && Pawn(SeenPlayer).PlayerReplicationInfo == None 
			&& !Pawn(SeenPlayer).IsA('StationaryPawn')) ) && VSize(Pawn(SeenPlayer).Velocity) > 70 )
		{
			Enemy = Pawn(SeenPlayer);
			GotoState('ActiveCannon');
		}
	}

	function timer() //Yes I need something
	{
		local Pawn P;
		if ( Enemy == None && Target == None && MyTeam == 0 )
		{
		for ( P=Level.PawnList; P!=None; P=P.NextPawn )
		{
			if ( VSize(P.Velocity) < 70 ) continue;
			if (P != None && P.PlayerReplicationInfo==None && !P.IsA('StationaryPawn') && CanSee(P) //This should be enough for the moment
			&& !P.bDeleteMe && !P.bHidden )
			{
				Enemy = P;
				GotoState('ActiveCannon');
				break;
			}
		}
		}
	}

	function BeginState()
	{
		Enemy = None;
	}

Begin:
	TweenAnim(AnimSequence, 0.25);
	Sleep(5.0);
	StartDeactivate();
	Sleep(0.0);
	PlayDeactivate();
	Sleep(2.0);
	SetPhysics(PHYS_None);
	SetTimer(1.0,True);
}

state ActiveCannon
{
	ignores SeePlayer;

	function EnemyNotVisible()
	{
		local Pawn P;

		Enemy = None;
		for ( P=Level.PawnList; P!=None; P=P.NextPawn )
		{
			if ( P != None && VSize(P.Velocity) < 70 ) continue;
               if ( P.bCollideActors && !P.bDeleteMe && !P.bHidden && P.bIsPlayer && (!Level.Game.bTeamGame || (P.PlayerReplicationInfo != None && !SameTeamAs(P.PlayerReplicationInfo.Team)))
				&& (P.Health > 0) && !P.IsA('TeamCannon')
				&& LineOfSightTo(P) || ( LineOfSightTo(P) && P.PlayerReplicationInfo == None && !P.IsA('StationaryPawn') && MyTeam == 0 ))
			{
				Enemy = P;
				if ( P.IsA('ScriptedPawn') && FRand() > 0.6 && ScriptedPawn(P).Enemy!=Self) //2) Convince Monster about this threat randomly
				{
					ScriptedPawn(P).Hated=Self;
					ScriptedPawn(P).Enemy=Self;
				}
				break;
			}
		}
		GotoState('Idle');
	}
	
	function Killed(pawn Killer, pawn Other, name damageType)
	{
		Global.Killed(Killer,Other,damagetype); //Meh, I think I won't stuck something here. Bullshit stopped.
		if ( Other == Enemy )
		{
			EnemyNotVisible(); //Seek next one
		}
	}

	function Timer()
	{
		local Pawn P;
		if ( Enemy != None && !Enemy.bHidden && !Enemy.bDeleteMe && LineOfSightTo(Enemy) ) //LOLZ
		{
			if ( Target == None ) //No target but exist enemy
				Target = Enemy; //Claim enemy as target
			if (Target == None )
			{
				GotoState('Idle');
				GoTo JL201;
			}
			DesiredRotation = rotator(Target.Location - Location); //track the target then
			DesiredRotation.Yaw = DesiredRotation.Yaw & 65535;
			if ( bShoot && (DesiredRotation.Pitch < 2000)
				&& ((Abs(DesiredRotation.Yaw - (Rotation.Yaw & 65535)) < 1000)
				|| (Abs(DesiredRotation.Yaw - (Rotation.Yaw & 65535)) > 64535)) )
				Shoot(); //Fire !!!
			else 
			{
				TweenAnim(PickAnim(), 0.25);
				bShoot=True;
				SetTimer(SampleTime,True);
			}
			if (Enemy.IsA('ScriptedPawn') && FRand() > 0.6) //Monster is not glad
			{
				ScriptedPawn(Enemy).Hated=Self;
				ScriptedPawn(Enemy).Enemy=Self;
			}
		}
JL201:
	}

	function BeginState()
	{
		if ( Enemy != None && !Enemy.bHidden && !Enemy.bDeleteMe && Target == None && LineOfSightTo(Enemy)) //Something much better
			Target = Enemy; //Right at begining
	}

Begin:
	Disable('Timer');
	FinishAnim();
	PlayActivate();
	FinishAnim();
	ActivateComplete();
	Enable('Timer');
	SetTimer(SampleTime,True);
	RotationRate.Yaw = TrackingRate;
	SetPhysics(PHYS_Rotating);
	bShoot=True;

FaceEnemy:
	if ( Enemy != None && LineOfSightTo(Enemy) ) //IF IF IF !!!
	{
		TurnToward(Enemy);
		Goto('FaceEnemy');
	}
	else {Target = None; Enemy = None; GotoState('Idle');} //Else stop hunting ghosts (probably your dead grandma haunts you)
}

defaultproperties
{
   FireSound=Sound'UnrealI.Cannon.CannonShot'
   ActivateSound=Sound'UnrealI.Cannon.CannonActivate'
   SampleTime=0.330000
   TrackingRate=25000
   Drop=60.000000
   ProjectileType=Class'Botpack.CannonShot'
   PostKillMessage="was killed by an automatic cannon!"
   SightRadius=3000.000000
   FovAngle=90.000000
   Health=220
   MenuName="automatic cannon!"
   NameArticle="an "
   RemoteRole=ROLE_SimulatedProxy
   AnimSequence=Activate
   Mesh=LodMesh'Botpack.cdgunmainM'
   CollisionRadius=28.000000
   RotationRate=(Yaw=25000)
}
