class MonsterReplicationInfo2 expands TournamentGameReplicationInfo;

var bool bUseLive, bUseTeamSkin, bIsAServer;
var int Live, Monster, Hunter, Ticks;
//=== MH specific add-ons

replication
{
	reliable if ( Role == ROLE_Authority ) //I think these are computed dynamically so they are updated often
		Live, Monster, bUseLive, Hunter, Ticks, bIsAServer;

	reliable if ( bNetInitial && Role == ROLE_Authority ) // bUseTeamSkin I think must be here right at start
		bUseTeamSkin;
}

simulated function PostBeginPlay()
{
	local int i;

//	Super.PostBeginPlay();
	if( Level.NetMode == NM_Client )
	{
		// clear variables so we don't display our own values if the server has them left blank 
		ServerName = "";
		AdminName = "";
		AdminEmail = "";
		MOTDLine1 = "";
		MOTDLine2 = "";
		MOTDLine3 = "";
		MOTDLine4 = "";
	}
	SecondCount = Level.TimeSeconds;
	SetTimer(0.5, true); //Slow down the spam

	if (TournamentGameInfo(Level.Game) != None)
	{
		TotalGames = TournamentGameInfo(Level.Game).EndStatsClass.Default.TotalGames;
		TotalFrags = TournamentGameInfo(Level.Game).EndStatsClass.Default.TotalFrags;
		TotalDeaths = TournamentGameInfo(Level.Game).EndStatsClass.Default.TotalDeaths;
		TotalFlags = TournamentGameInfo(Level.Game).EndStatsClass.Default.TotalFlags;
		for (i=0; i<3; i++)
		{
			BestPlayers[2-i] = TournamentGameInfo(Level.Game).EndStatsClass.Default.BestPlayers[i];
			BestFPHs[2-i] = TournamentGameInfo(Level.Game).EndStatsClass.Default.BestFPHs[i];
			BestRecordDate[2-i] = TournamentGameInfo(Level.Game).EndStatsClass.Default.BestRecordDate[i];
		}
	}
}

defaultproperties
{
}
