class NSMonsterHUD expands ChallengeTeamHUD config;

#exec texture IMPORT NAME=MHudIcon FILE=Textures\HUDIcon.pcx GROUP="Hud" MIPS=OFF LODSET=0
#exec TEXTURE IMPORT NAME=MBlackStuff FILE=Textures\BlackStuff.PCX GROUP="Hud" MIPS=OFF LODSET=0
#exec TEXTURE IMPORT NAME=MBlackStuff2 FILE=Textures\BlackStuff2.PCX GROUP="Hud" MIPS=OFF LODSET=0
#exec texture Import Name=radarconsole File=Textures\radarconsole.pcx GROUP="Hud" Mips=Off Flags=2
#exec Texture Import Name=monsterpoint File=Textures\Monsterpoint.pcx GROUP="Hud" Mips=Off Flags=2

#exec New TrueTypeFontFactory FontName="LucidaSansTypewriter" Name="BeaconNameFontSmall"  Height=8  USize=256 VSize=128 CharactersPerPage=256
#exec New TrueTypeFontFactory FontName="LucidaSansTypewriter" Name="BeaconNameFontMedium" Height=10 USize=256 VSize=128 CharactersPerPage=256
#exec New TrueTypeFontFactory FontName="LucidaSansTypewriter" Name="BeaconNameFontLarge"  Height=12 USize=256 VSize=256 CharactersPerPage=256
#exec Texture Import Name=TeamBeacon2 File="Textures\TeamBeacon2.pcx" Group="Hud" Flags=2

var texture tex;
var() config enum ES_Position
{
	RADAR_TopLeft,
	RADAR_TopMiddle,
	RADAR_TopRight,
	RADAR_MiddleLeft,
	RADAR_MiddleRight,
	RADAR_BottomLeft,
	RADAR_BottomMiddle,
	RADAR_BottomRight
} Position;
var PlayerPawn Player;

var localized string RankString;
var localized string SpreadString;

var() int Zscale;
var bool bActive, bHaveDamage;
var GameReplicationInfo GRI;
var int RespawnTimer/*,DamCharge*/;
var bool TimerFlip;

var PlayerReplicationInfo Ordered[32];

var() bool bHideSpectatorBeacons;
var Texture TeamBeaconIcon;
var color BeaconColor;

simulated function PostBeginPlay()
{
	Super.PostBeginPlay();
	Level.bHighDetailMode = True;
/*
	if (bUseTeamColor)
		bUseTeamColor=MonsterReplicationInfo2(PlayerPawn(Owner).GameReplicationInfo).bUseTeamSkin;
*/
	RespawnTimer=2;
	SetTimer(1.0,True);
}

function Timer ()
{
	local int i, j;

	// Audio clue you are gonna die: beep beep OMFG!
	if (PawnOwner != None && PawnOwner.Health < 75  && !PawnOwner.IsInState('Dying'))
		PawnOwner.PlaySound(Sound'UnrealShare.Beep');
	if ( PawnOwner != None )
		if ( PawnOwner.IsInState('Dying') && RespawnTimer == 0) // delay the respawn so player can see SB
			RespawnTimer = 10; // 10 sec
		else if (PawnOwner.IsInState('Dying') && RespawnTimer > 0 )
		{
			if (--RespawnTimer == 0)
			if ( PawnOwner != None )
				if (PawnOwner.IsA('PlayerPawn'))
					PlayerPawn(PawnOwner).ServerRestartPlayer();
		}
//Doesn't continue here
	if ( (PlayerOwner == None) || ( PawnOwner == None ) || (PlayerOwner.GameReplicationInfo == None)
		|| (PawnOwner.PlayerReplicationInfo == None) )
		GoTo JL129;
//blocked until here if owner none
	if ( TimerFlip )
		UpdateRankAndSpread();
	TimerFlip = !TimerFlip;
//add
	if (!bDrawMessageArea)
	{
		if (MessageFadeCount > 0)
		MessageFadeCount--;
	}

	// Age the short message queue.
	for (i=0; i<4; i++)
	{
		//Purge expired messages.
		if ( (ShortMessageQueue[i].Message != None) && (Level.TimeSeconds >= ShortMessageQueue[i].EndOfLife) )
			ClearMessage(ShortMessageQueue[i]);
	}

	// Clean empty slots.
	for (i=0; i<3; i++)
	{
	if ( ShortMessageQueue[i].Message == None )
		{
			for (j=i; j<4; j++)
			{
				if ( ShortMessageQueue[j].Message != None )
				{
					CopyMessage(ShortMessageQueue[i],ShortMessageQueue[j]);
					ClearMessage(ShortMessageQueue[j]);
				break;
				}
			}
		}
	}

	// Age all localized messages.
	for (i=0; i<10; i++)
	{
	// Purge expired messages.
	if ( (LocalMessages[i].Message != None) && (Level.TimeSeconds >= LocalMessages[i].EndOfLife) )
		ClearMessage(LocalMessages[i]);
	}

	// Clean empty slots.
	for (i=0; i<9; i++)
	{
	if ( LocalMessages[i].Message == None )
		{
		CopyMessage(LocalMessages[i],LocalMessages[i+1]);
		ClearMessage(LocalMessages[i+1]);
		}
	}
JL129:
}

simulated function SetIDColor( Canvas Canvas, int type )
{
	Canvas.DrawColor = GreenColor;
	if ( type == 0 )
		Canvas.DrawColor.G = 160 * (IdentifyFadeTime / 3.0);
	else
		Canvas.DrawColor.G = 255 * (IdentifyFadeTime / 3.0);
}

simulated function UpdateRankAndSpread()
{
	local PlayerReplicationInfo PRI;
	local int HighScore;
	local int i, j;

	PlayerCount = 0;
	HighScore = 0;
	bTiedScore = False;
	Rank = 1;
	if ( PlayerOwner == None || PlayerOwner.PlayerReplicationInfo == None )
		GoTo JL180;
	for (i=0; i<32; i++)
	{
		PRI = PlayerOwner.GameReplicationInfo.PRIArray[i];
		if ( PRI == None ) Continue;
		if ( (PRI != None) && (!PRI.bIsSpectator || PRI.bWaitingPlayer) )
		{
			PlayerCount++;
			if (PRI != PawnOwner.PlayerReplicationInfo)
			{
				if (PRI.Score > PawnOwner.PlayerReplicationInfo.Score)
					Rank += 1;
				else if (PRI.Score == PawnOwner.PlayerReplicationInfo.Score)
				{
					bTiedScore = True;
					if (PRI.Deaths < PawnOwner.PlayerReplicationInfo.Deaths)
						Rank += 1;
					else if (PRI.Deaths == PawnOwner.PlayerReplicationInfo.Deaths)
						if (PRI.PlayerID < PawnOwner.PlayerReplicationInfo.PlayerID)
							Rank += 1;
				}
				if (PRI.Score > HighScore)
					HighScore = PRI.Score;
			}
		}
	}
	if ( PawnOwner.PlayerReplicationInfo != None )
		Lead = int(PawnOwner.PlayerReplicationInfo.Score) - HighScore;
JL180:
}

simulated function DrawGameSynopsis(Canvas C)
{
	local float XL, YL, XOffset, YOffset, YOffsetSafe;
	local inventory Inv;
	local int BootCharges,FlashCharges/*,DamCharge1*/;
	local string Spread;
	local int i;

	if ((PawnOwner.PlayerReplicationInfo == None) || PawnOwner.PlayerReplicationInfo.bIsSpectator )
		GoTo JL311;

	i = 0;
	C.Font = MyFonts.GetSmallFont(C.ClipX);
	C.DrawColor = GoldColor;
	C.StrLen(RankString, XL, YL);
	if ( bHideAllWeapons )
		YOffset = C.ClipY - YL*6;
	else if ( HudScale * WeaponScale * C.ClipX <= C.ClipX - 256 * Scale )
		YOffset = C.ClipY - 64*scale - YL*6;
	else
		YOffset = C.ClipY - 128*Scale - YL*6;
	if ( MonsterReplicationInfo2(PlayerPawn(Owner).GameReplicationInfo) != None )
	{
		if ( MonsterReplicationInfo2(PlayerPawn(Owner).GameReplicationInfo).bIsAServer )
		{
			C.SetPos(0, YOffset - (YL*7));
			C.DrawColor = GoldColor;
			C.DrawText(" S_TR: "$MonsterReplicationInfo2(PlayerOwner.GameReplicationInfo).Ticks, false);
		}
	}
	C.SetPos(0, YOffset + (YL/2));
	C.DrawText(RankString@Rank@"/"@PlayerCount, False);

	if (Lead > 0)
	{
		Spread = SpreadString$" +"$Lead;
		C.DrawColor = GreenColor;
	}
	else if (Lead < 0)
	{
		Spread = SpreadString$" "$Lead;
		C.DrawColor = RedColor;
	}
	else
		{
		Spread = SpreadString$" "$Lead;
		C.DrawColor = GoldColor;
		}
	C.SetPos(0, YOffset + YL + (YL/2));
	C.DrawText(Spread, False);
	C.DrawColor = GoldColor;

	if (MonsterReplicationInfo2(PlayerPawn(Owner).GameReplicationInfo).bUseLive)
	{
		C.SetPos(0, YOffset + YL + YL + YL);
		C.DrawColor = GoldColor;
		C.DrawText(" Deaths: "$MonsterReplicationInfo2(PlayerOwner.GameReplicationInfo).Live - int(PawnOwner.PlayerReplicationInfo.Deaths), false);
	} 
	YOffsetSafe = YOffset; // make a safe copy
	YOffSet -= YL + YL;

	for ( Inv=PawnOwner.Inventory; Inv!=None; Inv=Inv.Inventory )
	{
		if ( Inv.IsA('mhscuba'))
		{
			C.DrawColor = BlueColor;
			if ((Inv.Charge/10) < 25) C.DrawColor = RedColor;
			C.SetPos(0, YOffset);
			C.DrawText(" Scuba: "@(Inv.Charge/10), False);
			YOffSet -= YL;
		}
		else if ( Inv.IsA('UT_Jumpboots') )
		{
			BootCharges=Inv.Charge;
			C.DrawColor = BlueColor;
			C.SetPos(0, YOffset);
			if (BootCharges < 100 || BootCharges > 0) //Better to not see some bullshit value
				C.DrawText(" Jumps left: "@Inv.Charge, False);
			YOffSet -= YL;
		}
		else if ( Inv.IsA('mhflashlight'))
		{
			FlashCharges=Inv.Charge;
			C.DrawColor = BlueColor;
			if ((Inv.Charge/10) < 100)
				C.DrawColor = RedColor;
			C.SetPos(0, YOffset);
			if (FlashCharges < 100000 || FlashCharges > 0)
				C.DrawText(" "$Inv.ItemName$": "@(Inv.Charge/10), False);
	//			C.DrawText(" Flashlight: "@(Inv.Charge/10), False);
			YOffSet -= YL;
		}
/*		else if ( Inv.IsA('UDamage'))
		{
			bHaveDamage = True;
			DamCharge1=UDamage(Inv).Charge/10;
			if ( DamCharge <= 0 )
				DamCharge = DamCharge1;
			C.DrawColor = BlueColor;
			C.SetPos(0, YOffset);
			if (DamCharge < 90001 || DamCharge > 0)
			{
				C.DrawText(" "$Inv.ItemName$": "@DamCharge, False);
			}
			YOffSet -= YL;
		}
*/
		else
		{
//			bHaveDamage=False;
			i++;
			if ( i > 100 )
				break; // can occasionally get temporary loops in netplay
		}
	}
	YOffset = YOffsetSafe;

	C.Font = MyFonts.GetSmallFont(C.ClipX);
	//Canvas.DrawColor = WhiteColor;
	C.DrawColor = GoldColor;
	C.SetPos(0, YOffset + YL + YL + YL + YL + YL);
//		Removed the team size since the information is already on the right side
//		Canvas.DrawText(" Team Size: "$string(MonsterReplicationInfo2(PlayerPawn(Owner).GameReplicationInfo).Hunter), False);
	if ((MonsterReplicationInfo2(PlayerPawn(Owner).GameReplicationInfo).Monster) < 10)
		C.DrawColor = RedColor;
	C.SetPos(0, YOffset + YL + YL + YL + YL + YL);
	C.DrawText(" Monsters Left: "$string(MonsterReplicationInfo2(PlayerPawn(Owner).GameReplicationInfo).Monster), False);
	C.DrawColor = WhiteColor;
	DrawRadar(C);
	DrawPlayerLists(C);
	if ( MonsterReplicationInfo2(PlayerPawn(Owner).GameReplicationInfo).bUseLive
		&& (PawnOwner.PlayerReplicationInfo.Deaths < 1) && !PawnOwner.IsA('Spectator') && !bHideHUD)
		DrawMBlackStuff(C);
	if (PawnOwner == PlayerOwner)
		DrawMonsterName(C);
JL311:
}

simulated function DrawFragCount (Canvas C)
{
	local float Whiten;
	local int X;
	local int Y;

	if ( PawnOwner.PlayerReplicationInfo == None )
	{
		GoTo JL374;
	}
	C.Style=Style;
	if ( bHideAllWeapons || (HUDScale * WeaponScale * C.ClipX <= C.ClipX - 256 * Scale) )
	{
		Y=C.ClipY - 63.50 * Scale;
	}
	else
	{
		Y=C.ClipY - 127.50 * Scale;
	}
	if ( bHideAllWeapons )
	{
		X = 0.50 * C.ClipX - 256 * Scale;
	}
	C.CurX=X;
	C.CurY=Y;
	C.DrawColor=HUDColor;
	Whiten=Level.TimeSeconds - ScoreTime;
	if ( Whiten < 3.00 )
	{
		if ( HUDColor==GoldColor )
		{
			C.DrawColor=WhiteColor;
		}
		else
		{
			C.DrawColor=GoldColor;
		}
		if ( Level.bHighDetailMode )
		{
			C.CurX=X - 64 * Scale;
			C.CurY=Y - 32 * Scale;
			C.Style=3;
			C.DrawTile(Texture'HUDWeapons',256.00 * Scale,128.00 * Scale,0.00,128.00,256.00,128.00);
		}
		C.CurX=X;
		C.CurY=Y;
		Whiten=4.00 * Whiten - 4 * Whiten;
		C.DrawColor=C.DrawColor + (HUDColor - C.DrawColor) * Whiten;
	}
	C.DrawTile(Texture'HudElements1',128.00 * Scale,64.00 * Scale,0.00,128.00,128.00,64.00);
	C.DrawColor=WhiteColor;

	if (int(PawnOwner.PlayerReplicationInfo.Score) >= 9999)
	{
		C.SetPos(X + 10 * Scale,Y + 16 * Scale);
		C.Font=MyFonts.GetHugeFont(C.ClipX);
		C.DrawText(int(PawnOwner.PlayerReplicationInfo.Score));
	}
	else
		DrawBigNum(C, int(PawnOwner.PlayerReplicationInfo.Score), X + 40 * Scale, Y + 16 * Scale);
JL374:
}

simulated function DrawAmmo(Canvas C)
{
	local int X,Y;

	C.Style = Style;
	C.DrawColor = HUDColor;
	if (bHideAllWeapons || (HudScale * WeaponScale * C.ClipX <= C.ClipX - 256 * Scale))
	Y = C.ClipY - 63.5 * Scale;
		else
	Y = C.ClipY - 127.5 * Scale;
	if ( bHideAllWeapons )
		X = 0.5 * C.ClipX + 128 * Scale;
	else
		X = C.ClipX - 128 * Scale;
	C.SetPos(X, Y);
	C.DrawTile(Texture'BotPack.HudElements1', 128*Scale, 64*Scale, 128, 192, 128.0, 64.0);

	if ((PawnOwner.Weapon == None) || (PawnOwner.Weapon.AmmoType == None))
		GoTo JL407;

	C.DrawColor = WhiteColor;

	if (PawnOwner.Weapon.AmmoType.AmmoAmount <= 999)
		DrawBigNum(C, PawnOwner.Weapon.AmmoType.AmmoAmount, X + 8 * Scale, Y + 16 * Scale);
	else
	{
		C.Font=MyFonts.GetHugeFont(C.ClipX);
		C.SetPos(X + 10 * Scale,Y + 16 * Scale);
		C.DrawText(PawnOwner.Weapon.AmmoType.AmmoAmount);
	}
JL407:
}

simulated function DrawStatus(Canvas C)
{
	local float X, Y;
	//Super.DrawStatus(Canvas);
	//C.DrawColor = HUDColor;
	if ( bHideStatus && bHideAllWeapons )
	{
		X = 0.5 * C.ClipX - 128 * Scale;
		Y = C.ClipY - 64 * Scale;
	}
	else
	{
//		X = C.ClipX - 128 * Scale * StatusScale - 140 * Scale;
		X = C.ClipX - 128 * Scale * StatusScale - 64 * Scale; //That's it, I want this one
		Y = 128 * Scale;
	}
	C.SetPos(X, Y);
	C.DrawTile(Texture'MH_A_V2.Hud.MHudIcon', 128*Scale, 64*Scale, 0, 192, 128.0, 64.0);
//	Canvas.DrawTile(Texture'MonsterHunt.Hud.HudIcon', 128*Scale, 64*Scale, 0, 192, 128.0, 64.0);
//	Canvas.DrawTile(Texture'MonsterHunt.Hud.BlackStuff', Canvas.ClipX, 160*Scale, 0, 0, 16, 64);
	DrawPlayerPic(C);
}

simulated function DrawPlayerPic(Canvas C)
{
	local float StatScale, ChestAmount, ThighAmount, H1, H2, X, Y, DamageTime;
	local int ArmorAmount,CurAbs,i;
	local inventory Inv,BestArmor;
	local bool bChestArmor, bShieldbelt, bThighArmor, bJumpBoots, bHasDoll;
	local Bot BotOwner;
	local TournamentPlayer TPOwner;
	local texture Doll, DollBelt;

	ArmorAmount = 0;
	CurAbs = 0;
	i = 0;
	BestArmor=None;

	for( Inv=PawnOwner.Inventory; Inv!=None; Inv=Inv.Inventory )
	{
		if (Inv.bIsAnArmor)
		{
			if ( Inv.IsA('MHUT_ShieldBelt') )
				bShieldbelt = true;
			else if ( Inv.IsA('MHThighPads') )
			{
				ThighAmount += Inv.Charge;
				bThighArmor = true;
			}
			else
			{
				bChestArmor = true;
				ChestAmount += Inv.Charge;
			}
			ArmorAmount += Inv.Charge;
		}
		else
			if ( Inv.IsA('UT_JumpBoots') )
				bJumpBoots = true;
		else
		{
			i++;
			if ( i > 100 )
				break; // can occasionally get temporary loops in netplay
		}
	}

	if ( !bHideStatus )
	{
		TPOwner = TournamentPlayer(PawnOwner);
		if ( C.ClipX < 400 )
			bHasDoll = false;
		else
			if ( TPOwner != None)
			{
				Doll = TPOwner.StatusDoll;
				DollBelt = TPOwner.StatusBelt;
				bHasDoll = true;
			}
			else
			{
				BotOwner = Bot(PawnOwner);
				if ( BotOwner != None )
				{
					Doll = BotOwner.StatusDoll;
					DollBelt = BotOwner.StatusBelt;
					bHasDoll = true;
				}
			}
			if ( bHasDoll )
			{
				C.Style = ERenderStyle.STY_Translucent;
				StatScale = (Scale * StatusScale)/1.6;  // shrink the playerpic
				X = C.ClipX - 128 * StatScale;
				C.SetPos(X, 0);
				if (PawnOwner.DamageScaling > 2.0)
					C.DrawColor = PurpleColor;
				else
					C.DrawColor = HUDColor;
				C.DrawTile(Doll, 128*StatScale, 256*StatScale, 0, 0, 128.0, 256.0);
				C.DrawColor = HUDColor;
				if ( bShieldBelt )
				{
					C.DrawColor = BaseColor;
					C.DrawColor.B = 0;
					C.SetPos(X, 0);
					C.DrawIcon(DollBelt, StatScale);
				}
				if ( bChestArmor )
				{
					ChestAmount = FMin(0.01 * ChestAmount,1);
					C.DrawColor = HUDColor * ChestAmount;
					C.SetPos(X, 0);
					C.DrawTile(Doll, 128*StatScale, 64*StatScale, 128, 0, 128, 64);
				}
				if ( bThighArmor )
				{
					ThighAmount = FMin(0.02 * ThighAmount,1);
					C.DrawColor = HUDColor * ThighAmount;
					C.SetPos(X, 64*StatScale);
					C.DrawTile(Doll, 128*StatScale, 64*StatScale, 128, 64, 128, 64);
				}
				if ( bJumpBoots )
				{
					C.DrawColor = HUDColor;
					C.SetPos(X, 128*StatScale);
					C.DrawTile(Doll, 128*StatScale, 64*StatScale, 128, 128, 128, 64);
				}
				C.Style = Style;
				if ( (PawnOwner == PlayerOwner) && Level.bHighDetailMode && !Level.bDropDetail )
				{
					for ( i=0; i<4; i++ )
					{
						DamageTime = Level.TimeSeconds - HitTime[i];
						if ( DamageTime < 1 )
						{
							C.SetPos(X + HitPos[i].X * StatScale, HitPos[i].Y * StatScale);
							if ( (HUDColor.G > 100) || (HUDColor.B > 100) )
								C.DrawColor = RedColor;
							else
								C.DrawColor = (WhiteColor - HudColor) * FMin(1, 2 * DamageTime);
							C.DrawColor.R = 255 * FMin(1, 2 * DamageTime);
							C.DrawTile(Texture'BotPack.HudElements1', StatScale * HitDamage[i] * 25, StatScale * HitDamage[i] * 64, 0, 64, 25.0, 64.0);
						}
					}
				}
			}
	}
	C.DrawColor = HUDColor;
	if ( bHideStatus && bHideAllWeapons )
	{
		X = 0.5 * C.ClipX;
		Y = C.ClipY - 64 * Scale;
	}
	else
	{
		X = C.ClipX - 128 * StatScale - 140 * Scale;
		Y = 64 * Scale;
	}
	C.SetPos(X,Y);
//  if ( PawnOwner.Health < 50 )
	if ( PawnOwner.Health < 75 )
	{
		H1 = 1.5 * TutIconBlink;
		H2 = 1 - H1;
		C.DrawColor = WhiteColor * H2 + (HUDColor - WhiteColor) * H1;
	}
	else
		C.DrawColor = HUDColor;
	C.DrawTile(Texture'BotPack.HudElements1', 128*Scale, 64*Scale, 128, 128, 128.0, 64.0);

//  if ( PawnOwner.Health < 50 )
	if ( PawnOwner.Health < 75 )
	{
		H1 = 1.5 * TutIconBlink;
		H2 = 1 - H1;
		C.DrawColor = C.DrawColor * H2 + (WhiteColor - C.DrawColor) * H1;
	}
	else
		C.DrawColor = WhiteColor;

	DrawBigNum(C, Max(0, PawnOwner.Health), X + 4 * Scale, Y + 16 * Scale, 1);

	C.DrawColor = HUDColor;
	if ( bHideStatus && bHideAllWeapons )
	{
		X = 0.5 * C.ClipX - 128 * Scale;
		Y = C.ClipY - 64 * Scale;
	}
	else
	{
		X = C.ClipX - 128 * StatScale - 140 * Scale;
		Y = 0;
	}
	C.SetPos(X, Y);
	C.DrawTile(Texture'BotPack.HudElements1', 128*Scale, 64*Scale, 0, 192, 128.0, 64.0);
	if ( bHideStatus && bShieldBelt )
		C.DrawColor = GoldColor;
	else
		C.DrawColor = WhiteColor;
	DrawBigNum(C, Min(150,ArmorAmount), X + 4 * Scale, Y + 16 * Scale, 1);
}

simulated function LocalizedMessage( class<LocalMessage> Message, optional int Switch, optional PlayerReplicationInfo RelatedPRI_1, optional PlayerReplicationInfo RelatedPRI_2, optional Object OptionalObject, optional String CriticalString )
{
	local int i;

	if ( ClassIsChildOf( Message, class'PickupMessagePlus' ) )
		PickupTime = Level.TimeSeconds;

	if ( !Message.Default.bIsSpecial )
	{
		if ( ClassIsChildOf(Message, class'SayMessagePlus') ||
			 ClassIsChildOf(Message, class'TeamSayMessagePlus') )
		{
			FaceTexture = RelatedPRI_1.TalkTexture;
			if ( FaceTexture != None )
				FaceTime = Level.TimeSeconds + 4;
		}
		// Find an empty slot.
		for (i=0; i<4; i++)
		{
			if ( ShortMessageQueue[i].Message == None )
			{
				ShortMessageQueue[i].Message = Message;
				ShortMessageQueue[i].Switch = Switch;
				ShortMessageQueue[i].RelatedPRI = RelatedPRI_1;
				ShortMessageQueue[i].OptionalObject = OptionalObject;
				ShortMessageQueue[i].EndOfLife = 7 + Level.TimeSeconds;
				if ( Message.Default.bComplexString )
					ShortMessageQueue[i].StringMessage = CriticalString;
				else
					ShortMessageQueue[i].StringMessage = Message.Static.GetString(Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject);
				GoTo JL722;
			}
		}
		// No empty slots.  Force a message out.
		for (i=0; i<3; i++)
			CopyMessage(ShortMessageQueue[i], ShortMessageQueue[i+1]);

		ShortMessageQueue[3].Message = Message;
		ShortMessageQueue[3].Switch = Switch;
		ShortMessageQueue[3].RelatedPRI = RelatedPRI_1;
		ShortMessageQueue[3].OptionalObject = OptionalObject;
		ShortMessageQueue[3].EndOfLife = 7 + Level.TimeSeconds;
		if ( Message.Default.bComplexString )
			ShortMessageQueue[3].StringMessage = CriticalString;
		else
			ShortMessageQueue[3].StringMessage = Message.Static.GetString(Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject);
		GoTo JL722;
	}
	else
	{
		if ( CriticalString == "" )
			CriticalString = Message.Static.GetString(Switch, RelatedPRI_1, RelatedPRI_2, OptionalObject);
		if ( Message.Default.bIsUnique )
		{
			for (i=0; i<10; i++)
			{
				if (LocalMessages[i].Message != None)
				{
					if ((LocalMessages[i].Message == Message)
						|| (LocalMessages[i].Message.Static.GetOffset(LocalMessages[i].Switch, 24, 640)
							== Message.Static.GetOffset(Switch, 24, 640)) )
					{
						LocalMessages[i].Message = Message;
						LocalMessages[i].Switch = Switch;
						LocalMessages[i].RelatedPRI = RelatedPRI_1;
						LocalMessages[i].OptionalObject = OptionalObject;
						LocalMessages[i].LifeTime = 7;
						LocalMessages[i].EndOfLife = 7 + Level.TimeSeconds;
						LocalMessages[i].StringMessage = CriticalString;
						LocalMessages[i].DrawColor = Message.Static.GetColor(Switch, RelatedPRI_1, RelatedPRI_2);
						LocalMessages[i].XL = 0;
						GoTo JL722;
					}
				}
			}
		}

		for (i=0; i<10; i++)
		{
			if (LocalMessages[i].Message == None)
			{
				LocalMessages[i].Message = Message;
				LocalMessages[i].Switch = Switch;
				LocalMessages[i].RelatedPRI = RelatedPRI_1;
				LocalMessages[i].OptionalObject = OptionalObject;
				LocalMessages[i].EndOfLife = 7 + Level.TimeSeconds;
				LocalMessages[i].StringMessage = CriticalString;
				LocalMessages[i].DrawColor = Message.Static.GetColor(Switch, RelatedPRI_1, RelatedPRI_2);
				LocalMessages[i].LifeTime = 7;
				LocalMessages[i].XL = 0;
				GoTo JL722;
			}
		}

		// No empty slots.  Force a message out.
		for (i=0; i<9; i++)
			CopyMessage(LocalMessages[i],LocalMessages[i+1]);

		LocalMessages[9].Message = Message;
		LocalMessages[9].Switch = Switch;
		LocalMessages[9].RelatedPRI = RelatedPRI_1;
		LocalMessages[9].OptionalObject = OptionalObject;
		LocalMessages[9].EndOfLife = 7 + Level.TimeSeconds;
		LocalMessages[9].StringMessage = CriticalString;
		LocalMessages[9].DrawColor = Message.Static.GetColor(Switch, RelatedPRI_1, RelatedPRI_2);
		LocalMessages[9].LifeTime = 7;
		LocalMessages[9].XL = 0;
		GoTo JL722;
	}
JL722:
}

simulated function Message( PlayerReplicationInfo PRI, coerce string Msg, name MsgType )
{
	local int i;
	local Class<LocalMessage> MessageClass;

	switch (MsgType)
	{
		case 'Say':
			MessageClass = class'SayMessagePlus';
			break;
		case 'TeamSay':
			MessageClass = class'TeamSayMessagePlus';
			break;
		case 'CriticalEvent':
			MessageClass = class'CriticalStringPlus';
			LocalizedMessage( MessageClass, 0, None, None, None, Msg );
			break;
		case 'MonsterCriticalEvent': //Ye... sure...
			MessageClass = class'MonsterCriticalString';
			LocalizedMessage( MessageClass, 0, None, None, None, Msg );
			break;
		case 'DeathMessage':
			MessageClass = class'RedSayMessagePlus';
			break;
		case 'Pickup':
			PickupTime = Level.TimeSeconds;
		default:
			MessageClass = class'StringMessagePlus';
			break;
	}

	if ( ClassIsChildOf(MessageClass, class'SayMessagePlus') ||
		ClassIsChildOf(MessageClass, class'TeamSayMessagePlus') )
	{
		FaceTexture = PRI.TalkTexture;
		FaceTeam = TeamColor[PRI.Team];
		if ( FaceTexture != None )
			FaceTime = Level.TimeSeconds + 4;
		if ( Msg == "" )
			GoTo JL798;
	}

	for (i=0; i<4; i++)
	{
		if ( ShortMessageQueue[i].Message == None )
		{
			// Add the message here.
			ShortMessageQueue[i].Message = MessageClass;
			ShortMessageQueue[i].Switch = 0;
			ShortMessageQueue[i].RelatedPRI = PRI;
			ShortMessageQueue[i].OptionalObject = None;
			ShortMessageQueue[i].EndOfLife = 5 + Level.TimeSeconds;
			if ( MessageClass.Default.bComplexString )
				ShortMessageQueue[i].StringMessage = Msg;
			else
				ShortMessageQueue[i].StringMessage = MessageClass.Static.AssembleString(self,0,PRI,Msg);
			GoTo JL798;
		}
	}

	// No empty slots.  Force a message out.
	for (i=0; i<3; i++)
		CopyMessage(ShortMessageQueue[i], ShortMessageQueue[i+1]);

	ShortMessageQueue[3].Message = MessageClass;
	ShortMessageQueue[3].Switch = 0;
	ShortMessageQueue[3].RelatedPRI = PRI;
	ShortMessageQueue[3].OptionalObject = None;
	ShortMessageQueue[3].EndOfLife = 5 + Level.TimeSeconds;
	if ( MessageClass.Default.bComplexString )
		ShortMessageQueue[3].StringMessage = Msg;
	else
		ShortMessageQueue[3].StringMessage = MessageClass.Static.AssembleString(self,0,PRI,Msg);
JL798:
}

simulated function DrawMBlackStuff(Canvas C)
{
	C.DrawColor = WhiteColor;
	C.Style = ERenderStyle.STY_Modulated;
	C.SetPos(0, 0);
	C.DrawTile(Texture'MH_A_V2.Hud.MBlackStuff', C.ClipX, 160*Scale, 0, 0, 16, 64);
	C.SetPos(0, C.ClipY - (160*Scale));
	C.DrawTile(Texture'MH_A_V2.Hud.MBlackStuff2', C.ClipX, 160*Scale, 0, 0, 16, 64);
	C.Style = ERenderStyle.STY_Translucent;
}

simulated function PostRender( Canvas C )
{
	local Actor Vt;

	if ( PlayerPawn(Owner) != None && PlayerPawn(Owner).ViewTarget != None )
		Vt = PlayerPawn(Owner).ViewTarget;
	if ( Pawn(Vt) != None && Pawn(Vt).PlayerReplicationInfo == None )
		GoTo JL826;
		Super.PostRender(C);
	//	super.HUDSetup(C);
	if ( (PawnOwner == None) || (PlayerOwner.PlayerReplicationInfo == None) )
		GoTo JL826;
	if ( C == none || bHideHUD ) GoTo JL826;
	if ( !bHideHUD && PawnOwner == PlayerOwner && C != None )
		DrawIdentifyInfo(C);
JL826:
}

simulated function HUDSetup(canvas canvas)
{
	local int FontSize;

	bResChanged = (Canvas.ClipX != OldClipX);
	OldClipX = Canvas.ClipX;

	PlayerOwner = PlayerPawn(Owner);
	if (PlayerOwner == None) {}
	if ( PlayerOwner.ViewTarget == None )
		PawnOwner = PlayerOwner;
	else if ( PlayerOwner.ViewTarget.bIsPawn )
		PawnOwner = Pawn(PlayerOwner.ViewTarget);
	else 
		PawnOwner = PlayerOwner;

	// Setup the way we want to draw all HUD elements
	Canvas.Reset();
	Canvas.SpaceX=0;
	Canvas.bNoSmooth = True;

	FontSize = Min(3, HUDScale * Canvas.ClipX/500);
	Scale = (HUDScale * Canvas.ClipX)/1280.0;

	Canvas.Font = MyFonts.GetSmallFont( Canvas.ClipX );

	SolidHUDColor = FavoriteHUDColor * 15.9;
	if ( (Opacity == 16) || !Level.bHighDetailMode )
	{
		Style = ERenderStyle.STY_Normal;
		BaseColor = WhiteColor;
		HUDColor = SolidHUDColor;
	}
	else
	{
		Style = ERenderStyle.STY_Translucent;
		BaseColor = (16 * Opacity + 15) * UnitColor;
		HUDColor = FavoriteHUDColor * (Opacity + 0.9);
	}
	Canvas.DrawColor = BaseColor;
	Canvas.Style = Style;
	bLowRes = ( Canvas.ClipX < 400 );
	if ( bLowRes )
		WeaponScale = 1.0;
}

simulated function DrawPlayerLists (Canvas C)
{
	local float XL, YL, YOffSetP, YOffSetS;
	local PlayerReplicationInfo PRI;
	local int PlayerCount, i;
	local string playerString;

	if (PlayerOwner.PlayerReplicationInfo == none || C == none) return;

	C.Font=C.SmallFont;
//	C.Font=C.MedFont;
	C.DrawColor=BlueColor;

	C.StrLen("[Player(LOCATION)] ", XL, YL);
	C.SetPos(C.ClipX - XL, C.ClipY / 4);
	C.DrawText("[Player(LOCATION)]",False);

	C.StrLen("[Spectators] ",XL,YL);
	C.SetPos(C.ClipX - XL,C.ClipY / 1.5);
	C.DrawColor=RedColor;
	C.DrawText("[Spectators] ",False);

	// Wipe everything.
	for ( i=0; i<ArrayCount(Ordered); i++ )
		Ordered[i] = None;
	for ( i=0; i<32; i++ )
	{
		if (PlayerPawn(Owner).GameReplicationInfo.PRIArray[i] != None)
		{
			PRI = PlayerPawn(Owner).GameReplicationInfo.PRIArray[i];
			if ( !PRI.bWaitingPlayer )
			{
				Ordered[PlayerCount] = PRI;
				PlayerCount++;
				if ( PlayerCount == ArrayCount(Ordered) )
					break;
			}
		}
	}

	SortScores(PlayerCount);

	YOffSetP = C.ClipY/4 + YL;
	YOffSetS = C.ClipY/1.5 + YL;

	for (i = 0; i < playerCount; ++i)
	{
		if (Ordered[i].PlayerName ~= "player")
		{
		}
		else
		{
			playerString = Ordered[i].PlayerName;
			if (!Ordered[i].bIsSpectator)
			{
				if (Ordered[i].PlayerLocation != none && Ordered[i].PlayerLocation.LocationName != "")
					playerString = playerString@"("$Ordered[i].PlayerLocation.LocationName$")";
				else if (Ordered[i].PlayerZone != none && Ordered[i].PlayerZone.ZoneName != "")
					playerString = playerString@"("$Ordered[i].PlayerZone.ZoneName$")";
			}

			if (len(playerstring) > 30)
			playerString = left(playerString, 30)$")"; // truncate if longer than 30 chars

			C.StrLen (playerString$" ", XL, YL);
			if (Ordered[i].bIsSpectator)
			{
				C.SetPos(C.ClipX - XL, YOffSetS);
				YOffSetS += YL;
			}
			else
			{
				C.SetPos(C.ClipX - XL, YOffSetP);
				YOffSetP += YL;
			}
			if (!Ordered[i].bIsSpectator && PlayerOwner.PlayerReplicationInfo.PlayerName == Ordered[i].PlayerName)
				C.DrawColor=GoldColor;
			else
				C.DrawColor=WhiteColor;

			C.DrawText (playerString, False);
		}
	}
}

function SortScores(int N)
{
	local int I, J, Max;
	local PlayerReplicationInfo TempPRI;

	for ( I=0; I<N-1; I++ )
	{
		Max = I;
		for ( J=I+1; J<N; J++ )
		{
			if ( Ordered[J].Score > Ordered[Max].Score )
				Max = J;
			else if ((Ordered[J].Score == Ordered[Max].Score) && (Ordered[J].Deaths < Ordered[Max].Deaths))
				Max = J;
			else if ((Ordered[J].Score == Ordered[Max].Score) && (Ordered[J].Deaths == Ordered[Max].Deaths) &&
					 (Ordered[J].PlayerID < Ordered[Max].Score))
				Max = J;
		}

		TempPRI = Ordered[Max];
		Ordered[Max] = Ordered[I];
		Ordered[I] = TempPRI;
	}
}

simulated function bool DrawIdentifyInfo(Canvas C)
{
	local float XL, YL, XOffset, X1;
	local Pawn P;

	if (C == none || MyFonts == none) return false;

	if ( !TraceIdentify(C))
		return false;

	C.Font = MyFonts.GetBigFont(C.ClipX);

	if (C.Font == none) return false;

	if( IdentifyTarget.PlayerName != "" )
		DrawTwoColorID(C,IdentifyName, IdentifyTarget.PlayerName, C.ClipY - 256 * Scale);

	C.StrLen("MYTEST", XL, YL);
	if( PawnOwner.PlayerReplicationInfo.Team == IdentifyTarget.Team )
	{
		P = Pawn(IdentifyTarget.Owner);
		C.Font = MyFonts.GetSmallFont(C.ClipX);
		if ( P != None )
			DrawTwoColorID(C,IdentifyHealth,string(P.Health), (C.ClipY - 256 * Scale) + 1.5 * YL);
	}
	return true;
}

simulated function bool TraceIdentify(Canvas C)
{
	local actor Other;
	local vector HitLocation, HitNormal, StartTrace, EndTrace;

	StartTrace = PawnOwner.Location;
	StartTrace.Z += PawnOwner.BaseEyeHeight;
	EndTrace = StartTrace + vector(PawnOwner.ViewRotation) * 2500.0;
	Other = Trace(HitLocation, HitNormal, EndTrace, StartTrace, true);

	if ( Pawn(Other) != None )
	{
		if ( Pawn(Other).bIsPlayer && !Other.bHidden )
		{
			IdentifyTarget = Pawn(Other).PlayerReplicationInfo;
			IdentifyFadeTime = 3.0;
		}
	}
	else if ( (Other != None) && SpecialIdentify(C, Other) )
		return false;

	if ( (IdentifyFadeTime == 0.0) || (IdentifyTarget == None) || IdentifyTarget.bFeigningDeath )
		return false;
	return true;
}

simulated function DrawMonsterName(Canvas C)
{
	local ScriptedPawn thisPawn;
	local vector X, Y, Z, CamLoc, TargetDir, Dir, XY;
	local rotator CamRot;
	local Actor Camera;
	local float BaseBeaconScale, BeaconScale, Dist, DistScale;
	local float TanFOVx, TanFOVy;
	local float TanX, TanY;
	local float dx, dy, FontY;
	local string BeaconText;

	C.Style = ERenderStyle.STY_Masked;
	if (C.ClipX > 1024)
		C.Font = Font'BeaconNameFontLarge';
	else if (C.ClipX > 640)
		C.Font = Font'BeaconNameFontMedium';
	else
		C.Font = Font'BeaconNameFontSmall';

	C.SetPos(0, 0);
	C.TextSize("X", dx, FontY);
	BaseBeaconScale = 1.5 * FontY / Texture'MH_A_V2.Hud.TeamBeacon2'.VSize;

	C.ViewPort.Actor.PlayerCalcView(Camera, CamLoc, CamRot);

	TanFOVx = Tan(C.ViewPort.Actor.FOVAngle / 114.591559); // 360/Pi = 114.5915590...
	TanFOVy = (C.ClipY / C.ClipX) * TanFOVx;
	GetAxes(CamRot, X, Y, Z);

	C.bNoSmooth = False;
	C.Style = ERenderStyle.STY_Masked;
	foreach AllActors(class'ScriptedPawn', thisPawn) 
	{
//		if (thisPawn != none && thisPawn != Camera && thisPawn.Health > 0)
		if ( thisPawn != none && thisPawn != Camera && thisPawn.Health > 0 && !thisPawn.bHidden && thisPawn.Team < 4)
			{
			TargetDir = thisPawn.Location - CamLoc;
			Dist = VSize(TargetDir) * FMin(TanFOVx, 1.0);
			TargetDir = Normal(TargetDir + vect(0,0,1) * thisPawn.CollisionHeight);
			DistScale = FMin(100.0 * thisPawn.CollisionRadius / Dist, 1.0);

			if (DistScale > 0.5 && TargetDir dot X > 0 && (FastTrace(thisPawn.Location, CamLoc) || FastTrace(thisPawn.Location + vect(0,0,0.8) * thisPawn.CollisionHeight, CamLoc))) {
				BeaconScale = BaseBeaconScale * DistScale;
				Dir = X * (X dot TargetDir);
				XY = TargetDir - Dir;
				
				dx = C.ClipX * 0.5 * (1.0 + (XY dot Y) / (VSize(Dir) * TanFOVx));
				dy = C.ClipY * 0.5 * (1.0 - (XY dot Z) / (VSize(Dir) * TanFOVy));
				
//				C.DrawColor = BeaconColor;
				C.DrawColor = GreenColor;
				C.SetPos(dx - 0.5 * BeaconScale * TeamBeaconIcon.USize, dy - 2 * FontY * DistScale);
				//C.DrawIcon(TeamBeaconIcon, BeaconScale);
				
				// only draw name if close enough
				if (DistScale == 1.0)
				{
//					BeaconText = thisPawn.PlayerReplicationInfo.PlayerName;
					if (C.ClipX > 600)
						//BeaconText = BeaconText @ "(" $ thisPawn.Health $ ")";
						BeaconText = "" $ thisPawn.Health $ "";
					// shadow
					C.SetPos(dx + 0.6 * BeaconScale * TeamBeaconIcon.USize + 1, dy - 1.75 * FontY + 1);
					C.DrawColor = BeaconColor * 0.125;
					C.DrawTextClipped(BeaconText, False);

					// color
					C.SetPos(dx + 0.6 * BeaconScale * TeamBeaconIcon.USize, dy - 1.75 * FontY);
					C.DrawColor = BeaconColor;
					C.DrawTextClipped(BeaconText, False);
				}
			}
		}
	}
}

simulated function DrawRadar(Canvas C)
{
	local ScriptedPawn Monster;
	local int index, radius;
	local int originX, originY;
	local Pawn P;

	if(!Owner.IsA('PlayerPawn'))
	{
		Log("Owner: ("$Owner$") does not want me loaded", Class.Name);
		GoTo JL1182;
	}

	C.Reset();

//	radius = Canvas.sizeY/16;
	radius = C.sizeY/13;

	switch(Position)
	{
	case RADAR_TopLeft:
		originX = 30;
		originY = 30;
	break;
		case RADAR_TopMiddle:
		originX = C.SizeX/2 - radius;
		originY = 30;
	break;
		case RADAR_TopRight:
		originX = C.SizeX - radius*2 - 30;
		originY = 30;
	break;
		case RADAR_MiddleLeft:
		originX = 10;
//originY = C.SizeY/2 - radius;
		originY = C.SizeY/1.75 - radius;
	break;
		case RADAR_MiddleRight:
//originX = C.SizeX - radius - 80;
		originX = C.SizeX - radius - 100;
//originY = C.SizeY/2 - radius;
		originY = C.SizeY/1.7 - radius;
	break;
		case RADAR_BottomLeft:
		originX = 30;
		originY = C.SizeY - radius*2 - 30;
	break;
		case RADAR_BottomMiddle:
		originX = C.SizeX/2 - radius;
		originY = C.SizeY - radius*2 - 30;
	break;
		case RADAR_BottomRight:
		originX = C.SizeX - radius*2 - 30;
		originY = C.SizeY - radius*2 - 30;
	break;
	}
	C.Style = ERenderStyle.STY_Translucent;    // new attempt at transparency
	C.SetPos(originX, originY);
	C.DrawTile(tex, radius*2, radius*2, 0, 0, 128, 128);

	foreach AllActors(class'ScriptedPawn', Monster)
	{
		if(Monster.Health <= 0) continue;
			drawBlip(Monster, C, originX, originY, radius);
	}
JL1182:
}

simulated function DrawBlip(Pawn other, Canvas Canvas, int originX, int originY, int radius)
{
	local rotator myRotation, monsterRotation, blipRotation;
	local int x, y, monsterDistance;
	local Vector point, myLocation, monsterLocation;
	local Weapon weapon;
	local PlayerPawn pOwner;

	if(other.Health <= 0)
	{
		Canvas.DrawColor.R = 255;
		Canvas.DrawColor.G = 0;
		Canvas.DrawColor.B = 0;
	} 
	else
	{
		Canvas.DrawColor.R = 255;
		Canvas.DrawColor.G = 255;
		Canvas.DrawColor.B = 255;
	}
//Error logging
	if(Owner == none)
	{
		Log("draw MonsterPoint: I don't have an owner!", Class.Name);
		GoTo JL1262;
	}

	pOwner = PlayerPawn(Owner);
	if(pOwner == none)
	{
		Log("draw Monster Point: pOwner is null!", Class.Name);
		GoTo JL1262;
	}

	if(Canvas == none || other == none)
	{
		Log("draw Monster Point: Canvas: "$Canvas$", other: "$other, Class.Name);
		GoTo JL1262;
	}

	weapon = pOwner.Weapon;
	if(Weapon != none && Weapon.IsA('WarheadLauncher') &&
	WarheadLauncher(Weapon).bGuiding &&
	WarheadLauncher(Weapon).GuidedShell != none)
	{
		myLocation = WarheadLauncher(Weapon).GuidedShell.Location;
	} 
		else
	{
		myLocation = Owner.Location;
	}
	myLocation.z = 0;

	myRotation = pOwner.ViewRotation;
	myRotation.Yaw  += 16384;
	myRotation.Pitch = 0;
	myRotation.Roll  = 0;

	monsterLocation   = other.Location;
	monsterLocation.z = 0;
	point = myLocation - monsterLocation;
	monsterDistance = VSize(point);
	monsterRotation = rotator(point);
	monsterRotation.Pitch = 0;
	monsterRotation.Roll  = 0;

	blipRotation = myRotation - monsterRotation;

	point = monsterDistance * vector(blipRotation);

	if(VSize(point) < radius*50)
	{
		point.x = -point.x / 50 + radius + originX;
		point.y = point.y / 50 + radius + originY;
		Canvas.SetPos(point.x, point.y);
		Canvas.DrawTile(Texture'MH_A_V2.Hud.monsterpoint', 3, 3, 0, 0, 2, 2);
	}
JL1262:
}

function setZscale(int value)
{
	if(value < 1) value = 1;
	scale = value;
}

simulated function DrawInfo(Canvas C)
{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
	local actor Other;
	local Pawn PawnOwner;
	local rotator AdjustedAim;
	PawnOwner = Pawn(Owner);
	if ( PawnOwner == None ) GoTo JL1287;
	GetAxes(PawnOwner.ViewRotation,X,Y,Z);
	StartTrace	= Owner.Location + PawnOwner.Eyeheight * Z;
	AdjustedAim	= PawnOwner.AdjustAim(1000000, StartTrace, 0, False, False);
	X			= vector(AdjustedAim);
	EndTrace	= StartTrace + 10000 * X;
	Other		= PawnOwner.TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);
	ProcessTrace(C, Other);
JL1287:
}

simulated function ProcessTrace(Canvas C, Actor Other)
{
	local int originX, originY;
	local Pawn pawnOther;

	originX = C.SizeX / 2 - 100;
	originY = C.SizeY / 2 + 100;

	if( Other == none || !Other.IsA('ScriptedPawn') ) GoTo JL1310;

	C.Reset();

	C.DrawColor.R = 255;
	C.DrawColor.G = 255;
	C.DrawColor.B = 255;
	C.Font = C.SmallFont;
	pawnOther = Pawn(Other);
	C.setPos(originX, originY);
	C.drawText("Name: " $ pawnOther.getHumanName());
	C.setPos(originX, originY+10);
	C.drawText("Health: " $ pawnOther.Health);
JL1310:
}

defaultproperties
{
   Tex=Texture'MH_A_V2.HUD.radarconsole'
   Position=RADAR_MiddleRight
   RankString=" Rank:"
   SpreadString=" Spread:"
   Zscale=40
   TeamBeaconIcon=Texture'MH_A_V2.HUD.TeamBeacon2'
   BeaconColor=(G=150)
   bAlwaysRelevant=True
   bNetTemporary=True
   bHideSpectatorBeacons=False
}
