//=============================================================================
// WarShell.
//=============================================================================
class NSWarShell expands Projectile;
var float CannonTimer, SmokeRate;
var redeemertrail trail;
var NavigationPoint Safety;
var Pawn Bot, Loser, Clown;
var bool bOwnerAI;

simulated function Timer()
{
	local ut_SpriteSmokePuff b;
	local NavigationPoint N;
	local RedeFear rf;

		if ( Role == ROLE_Authority && Pawn(Owner) != None )
			Loser = Pawn(Owner);
		if ( Loser != None && Loser.IsA('Bot')&& Loser.Health > 10 )
		{
			bOwnerAI=True;
			if (Safety == None)
			{
				foreach Loser.RadiusActors( class 'NavigationPoint',N, 3000 )
				{
					if ( N != None 
					&& ((!FastTrace( Location,N.Location )) || VSize(Location-N.Location) > 1800 )
					&& !N.Region.Zone.bWaterZone && !N.IsA('SpawnPoint') )
					{
						Safety = N;
						Break;
					}
				}
			}
			if ( Safety != None && Loser != None && Loser.bCanWalk && !Loser.Region.Zone.bWaterZone )
			{
				if ( VSize(Safety.Location - Loser.Location) > 50 )
				{
					Loser.bFire = 0;
					Loser.bAltFire = 0;
					Bot(Loser).bComboPaused = True;
					if ( Loser.ActorReachable(Safety) )
						Loser.MoveTarget = Safety;
					else
						Loser.MoveTarget = Loser.FindPathToward(Safety);
					if ( Loser.MoveTarget != None )
					{
						Loser.MoveTimer = 1.00;
						Loser.TweenToRunning(0.1);
					}
				}
				else if ( VSize(Safety.Location - Loser.Location) <= 50 )
				{
					if ( VSize(Bot(Loser).Velocity) > 100 )
					{
						Bot(Loser).Acceleration = vect(0,0,0);
						Bot(Loser).CampTime = 2.5;
						Bot(Loser).GotoState('Roaming','Camp');
					}
				}
			}
			else if ( Safety == None && !Bot(Loser).IsInState('FallBack') )
				Bot(Loser).GotoState('FallBack');
//				Bot(Loser).CampTime = 2.00;
		}

		if (bOwnerAI)
		{
			rf = Spawn( class'RedeFear',,,Location+vect(100,0,0));
			if ( rf != None )
			{
				rf.SetPhysics(PHYS_Falling);
			}
		}

//trail
	if ( Trail == None )
		Trail = Spawn(class'RedeemerTrail',self);

	CannonTimer += SmokeRate;
	if ( CannonTimer > 0.6 )
	{
		WarnCannons();
		CannonTimer -= 0.6;
	}

	if ( Region.Zone.bWaterZone || (Level.NetMode == NM_DedicatedServer) )
	{
		SetTimer(SmokeRate, false);
		GoTo JL108;
	}

	if ( Level.bHighDetailMode )
	{
		if ( Level.bDropDetail )
			Spawn(class'LightSmokeTrail');
		else
			Spawn(class'UTSmokeTrail');
		SmokeRate = 152/Speed;
	}
	else
	{
		SmokeRate = 0.15;
		b = Spawn(class'ut_SpriteSmokePuff');
		b.RemoteRole = ROLE_None;
	}
	SetTimer(SmokeRate, false);
JL108:
}

simulated function Destroyed()
{
	if ( Trail != None )
		Trail.Destroy();
	Super.Destroyed();
}

simulated function PostBeginPlay()
{
	SmokeRate = 0.3;
	SetTimer(0.3,false);
}

function WarnCannons()
{
	local Pawn P;

	for ( P=Level.Pawnlist; P!=None; P=P.NextPawn )
		if ( P.IsA('TeamCannon') && !P.IsInState('TrackWarhead') && P.LineOfSightTo(self) )
		{
			P.target = self;
			P.GotoState('TrackWarhead');
		}
}

singular function TakeDamage( int NDamage, Pawn instigatedBy, Vector hitlocation,
						vector momentum, name damageType )
{
	local Pawn P;

	if ( NDamage > 5 )
	{
		PlaySound(Sound'Expl03',,6.0);
		spawn(class'WarExplosion',,,Location);
		HurtRadius(Damage,350.0, MyDamageType, MomentumTransfer, HitLocation );
		RemoteRole = ROLE_SimulatedProxy;
 		Destroy();

		if ( InstigatedBy != None && !InstigatedBy.bDeleteMe )
		{
			BroadcastMessage (InstigatedBy.GetHumanName()@"DESTROYED A REDEEMER.");
//			log("Step 1) Attempt Pawn kill message...");
		}
		else
		{
			BroadcastMessage ("A REDEEMER WAS DESTROYED BY A LOST PROJECTILE.");
//			log ("Step 2) Attempt lost message...");
			goto EndDamage;
		}

		foreach AllActors (class 'Pawn', P)
//		for ( P=Level.PawnList; P != None; P=P.nextPawn )
		{ // work through pawn list
    		if ( P != None && ( TournamentPlayer(P) != None || MessagingSpectator(P) != None ) )
			{
				if ( InstigatedBy != None && !InstigatedBy.bDeleteMe && Pawn(Owner) != None )
				{
					if ( Instigatedby != Owner )
						P.ClientMessage(InstigatedBy.GetHumanName()@" destroyed "@Pawn(Owner).GetHumanName()@"'s Redeemer.",'CriticalEvent',True);
					else
						P.ClientMessage(InstigatedBy.GetHumanName()@" has attacked an owned Redeemer.",'CriticalEvent',True);
				}
			}
		} // work through pawn list - Nope, changed
	}
	EndDamage:
}

auto state Flying
{

	simulated function ZoneChange( Zoneinfo NewZone )
	{
		local waterring w;

		if ( NewZone.bWaterZone != Region.Zone.bWaterZone )
		{
			w = Spawn(class'WaterRing',,,,rot(16384,0,0));
			if (w != None)
			{
				w.DrawScale = 0.2;
				w.RemoteRole = ROLE_None;
			}
		}
	}

	function ProcessTouch (Actor Other, Vector HitLocation)
	{
		if ( Other != instigator )
			Explode(HitLocation,Normal(HitLocation-Other.Location));
	}

	function Explode(vector HitLocation, vector HitNormal)
	{
		if ( Role < ROLE_Authority )
			GoTo JL209;

		HurtRadius(Damage,300.0, MyDamageType, MomentumTransfer, HitLocation );
		spawn(class'ShockWave',,,HitLocation+ HitNormal*16);
		RemoteRole = ROLE_SimulatedProxy;
		Destroy();
JL209:
	}

	function BeginState()
	{
		local vector InitialDir;

		initialDir = vector(Rotation);
		if ( Role == ROLE_Authority )
			Velocity = speed*initialDir;
		Acceleration = initialDir*50;
	}
}

defaultproperties
{
   speed=620.000000
   Damage=3000.000000
   MomentumTransfer=100000
   MyDamageType=RedeemerDeath
   ExplosionDecal=Class'Botpack.NuclearMark'
   bNetTemporary=False
   RemoteRole=ROLE_SimulatedProxy
   AmbientSound=Sound'Botpack.Redeemer.WarFly'
   Mesh=LodMesh'Botpack.missile'
   AmbientGlow=78
   bUnlit=True
   SoundRadius=100
   SoundVolume=255
   CollisionRadius=15.000000
   CollisionHeight=8.000000
   bProjTarget=True
}
