//=============================================================================
// TournamentPlayer for MH
//=============================================================================
class NsTournamentPlayer expands TournamentPlayer;

#exec AUDIO IMPORT FILE="Sounds\NsBeep.wav" NAME="MBeep" GROUP="Snd"

//var bool bHasBeacon;
var float LastSeekTime, LastJetLiTime;
var Actor Node;

function PreCacheReferences()
{	//never called - here to force precaching of meshes like in any normal UT game...
	//continuing mission in attempt to reduce lag as much as possible
	Spawn(Class'UnrealShare.BruteCarcass');
	Spawn(Class'UnrealShare.LesserBruteCarcass');
	Spawn(Class'UnrealShare.CowCarcass');
	Spawn(Class'UnrealShare.DevilfishCarcass');
	Spawn(Class'UnrealShare.FlyCarcass');
	Spawn(Class'UnrealI.GassiusCarcass');
	Spawn(Class'UnrealI.KrallCarcass');
	Spawn(Class'UnrealShare.MantaCarcass');
	Spawn(Class'UnrealI.MercCarcass');
	Spawn(Class'UnrealShare.NaliCarcass');
	Spawn(Class'UnrealI.PupaeCarcass');
	Spawn(Class'UnrealShare.CreatureCarcass');
	Spawn(Class'CreatureChunks');
	Spawn(Class'UnrealShare.SkaarjCarcass');
	Spawn(Class'UnrealI.TrooperCarcass');
	Spawn(Class'UnrealShare.SlithCarcass');
	Spawn(Class'UnrealShare.TentacleCarcass');
//	Spawn(Class'MonsterHunt.RockTentacleCarcass');
//	Spawn(Class'MonsterHunt.WaterTitanCarcass');
//	Spawn(Class'MonsterHunt.LavaSlithCarcass');
//	Spawn(Class'MonsterHunt.LavaTitanCarcass');
	Spawn(Class'UnrealI.WarlordCarcass');
	Spawn(Class'Unrealshare.CreatureChunks');
//	Spawn(class'ExCreatureCarcass');
//	Spawn(class'ExCreatureChunks');

	//Reinforce Defaults
	spawn(class'TMale1');
	spawn(class'TMale2');
	spawn(class'TFemale1');
	spawn(class'TFemale2');
	spawn(class'TBoss');
	spawn(class'ImpactHammer');
	spawn(class'Translocator');
	spawn(class'Enforcer');
	spawn(class'UT_Biorifle');
	spawn(class'ShockRifle');
	spawn(class'PulseGun');
	spawn(class'Ripper');
	spawn(class'Minigun2');
	spawn(class'UT_FlakCannon');
	spawn(class'UT_Eightball');
	spawn(class'SniperRifle');
	spawn(class'WarheadLauncher');
	//Now Let's see the options for old weaponry
	//These are in fact meshes used - originals
	Spawn(class'UnrealShare.ASMD');
	Spawn(class'UnrealShare.AutoMag');
	Spawn(class'UnrealShare.DispersionPistol');
	Spawn(class'UnrealShare.Eightball');
	Spawn(class'UnrealI.FlakCannon');
	Spawn(class'UnrealI.GESBioRifle');
	Spawn(class'UnrealI.Minigun');
	Spawn(class'UnrealI.QuadShot');
	Spawn(class'UnrealI.Razorjack');
	Spawn(class'UnrealI.Rifle');
	Spawn(class'UnrealShare.Stinger');
}

simulated function PlayBeepSound()
{
	PlaySound( Sound'MBeep',SLOT_Interface,2.0 );
}

event bool EncroachingOn( actor Other )
{
	if ( GameReplicationInfo != None && GameReplicationInfo.bTeamGame && Other.bIsPawn 
		&& (Pawn(Other).PlayerReplicationInfo != None) && PlayerReplicationInfo != None
		&& (Pawn(Other).PlayerReplicationInfo.Team == PlayerReplicationInfo.Team) )
	{
		if ( (Role == ROLE_Authority) && DeathMatchPlus(Level.Game) != None
			&& DeathMatchPlus(Level.Game).bStartMatch )
			return Super(Pawn).EncroachingOn(Other);
		else
			return true;
	}
	return Super(Pawn).EncroachingOn(Other);
}

exec function Fire( optional float F )
{
	if ( Weapon != None )
	{
		bJustFired = true;
		if( bShowMenu || (Level.Pauser!="") || (Role < ROLE_Authority) )
		{
			if ( Role < ROLE_Authority && Weapon != None )
				if ( Weapon.IsA('TournamentWeapon') )
					bJustFired = Weapon.ClientFire(F);
			if ( !bShowMenu && (Level.Pauser == PlayerReplicationInfo.PlayerName)  )
				SetPause(False);
			GoTo JL112;
		}
		Weapon.bPointing = true;
		PlayFiring();
		Weapon.Fire(F);
	}
JL112:
}

exec function AltFire( optional float F )
{
	if ( Weapon != None )
	{
		bJustAltFired = true;
		if( bShowMenu || (Level.Pauser!="") || (Role < ROLE_Authority) )
		{
			if ( Role < ROLE_Authority && Weapon != None )
				if ( Weapon.IsA('TournamentWeapon') )
					bJustAltFired = Weapon.ClientAltFire(F);
			if ( !bShowMenu && (Level.Pauser == PlayerReplicationInfo.PlayerName) )
				SetPause(False);
			return;
		}
		if ( Weapon != None )
		{
			Weapon.bPointing = true;
			PlayFiring();
			Weapon.AltFire(F);
		}
	}
JL136:
}

function PlayFiring()
{
	// switch animation sequence mid-stream if needed
	if (AnimSequence == 'RunLG')
		AnimSequence = 'RunLGFR';
	else if (AnimSequence == 'RunSM')
		AnimSequence = 'RunSMFR';
	else if (AnimSequence == 'WalkLG')
		AnimSequence = 'WalkLGFR';
	else if (AnimSequence == 'WalkSM')
		AnimSequence = 'WalkSMFR';
	else if ( AnimSequence == 'JumpSMFR' )
		TweenAnim('JumpSMFR', 0.03);
	else if ( AnimSequence == 'JumpLGFR' )
		TweenAnim('JumpLGFR', 0.03);
	else if ( (GetAnimGroup(AnimSequence) == 'Waiting') || (GetAnimGroup(AnimSequence) == 'Gesture')
		&& (AnimSequence != 'TreadLG') && (AnimSequence != 'TreadSM') )
	{
		if ( Weapon.Mass < 20 )
			TweenAnim('StillSMFR', 0.02);
		else
			TweenAnim('StillFRRP', 0.02);
	}
}

function SendClientFire(weapon W, int N)
{
	if ( Weapon != None )
	{
		RealWeapon(W,N);
		if ( Weapon.IsA('TournamentWeapon') )
		{
			TournamentWeapon(Weapon).bCanClientFire = true;
			TournamentWeapon(Weapon).ForceClientFire();
		}
	}
}

function SendClientAltFire(weapon W, int N)
{
	if ( Weapon != None )
	{
		RealWeapon(W,N);
		if ( Weapon.IsA('TournamentWeapon') )
		{
			TournamentWeapon(Weapon).bCanClientFire = true;
			TournamentWeapon(Weapon).ForceClientAltFire();
		}
	}
}

function ClientPutDown(Weapon Current, Weapon Next)
{
	if ( Role == ROLE_Authority )
		GoTo JL213;
	bNeedActivate = false;
	if ( (Current != None) && (Current != Next) )
		if ( Next != None && Next.IsA('TournamentWeapon'))
			Current.ClientPutDown(Next);
	else if ( Weapon != None )
	{
		if ( Weapon != Next && Weapon.IsA('TournamentWeapon') )
			Weapon.ClientPutDown(Next);
		else
		{
			bNeedActivate = false;
			ClientPending = None;
			if ( Weapon.IsInState('ClientDown') || !Weapon.IsAnimating() )
			{
				Weapon.GotoState('');
				Weapon.TweenToStill();
			}
		}
	}
JL213:
}

function RealWeapon(weapon Real, int N)
{
	if ( N <= WeaponUpdate )
		GoTo JL231;
	WeaponUpdate = N;
	Weapon = Real;
	if ( (Weapon != None) && !Weapon.IsAnimating() )
	{
		if ( (bNeedActivate || (Weapon == ClientPending)) )
			Weapon.GotoState('ClientActive');
		else
			Weapon.TweenToStill();
	}
	bNeedActivate = false;
	ClientPending = None;	// make sure no client side weapon changes pending
JL231:
}

function ReplicateMove
(
	float DeltaTime, 
	vector NewAccel, 
	eDodgeDir DodgeMove, 
	rotator DeltaRot
)
{
	Super(PlayerPawn).ReplicateMove(DeltaTime,NewAccel,DodgeMove,DeltaRot);
	if ( (Weapon != None) && !Weapon.IsAnimating() )
	{
		if ( ((Weapon == ClientPending) || (Weapon != OldClientWeapon)) && Weapon.IsA('TournamentWeapon'))
		{
			if ( Weapon.IsInState('ClientActive') )
				AnimEnd();
			else
				Weapon.GotoState('ClientActive');
			if ( (Weapon != ClientPending) && (myHUD != None) && myHUD.IsA('ChallengeHUD') )
				ChallengeHUD(myHUD).WeaponNameFade = 1.3;
			if ( (Weapon != OldClientWeapon) && (OldClientWeapon != None) )
				OldClientWeapon.GotoState('');

			ClientPending = None;
			bNeedActivate = false;
		}
		else
		{
			Weapon.GotoState('');
			Weapon.TweenToStill();
		}
	}
	OldClientWeapon = Weapon;
}

//===== Section nasty ======

exec function FeignDeath() //No shit me anyway
{
}

function ServerFeignDeath()
{
}

function PlayFeignDeath()
{
/*	local float decision;

	BaseEyeHeight = 0;
	decision = frand();
	if ( decision < 0.33 )
		TweenAnim('DeathEnd', 0.5);
	else if ( decision < 0.67 )
		TweenAnim('DeathEnd2', 0.5);
	else 
		TweenAnim('DeathEnd3', 0.5);
*/
}

exec function Amphibious()
{
	if( !bCheatsEnabled )
		GoTo JL307;

	if ( !bAdmin && (Level.Netmode != NM_Standalone) )
	{
		ClientMessage("Operation forbidden because of ScubaGear too wick... loser.");
		Spawn(Class'ShockWave',Self,,Location,Self.ViewRotation);
		if ( PlayerReplicationInfo != None )
			PlayerReplicationInfo.Score -= 5000;
		GoTo JL307;
	}
	UnderwaterTime = +999999.0;
JL307:
}

exec function Fly()
{
	if( !bCheatsEnabled )
		GoTo JL329;

	if ( !bAdmin && (Level.Netmode != NM_Standalone) )
	{
		ClientMessage("Operation forbidden because of Missing Wings... loser.");
		Spawn(Class'ShockWave',Self,,Location,Self.ViewRotation);
		if ( PlayerReplicationInfo != None )
			PlayerReplicationInfo.Score -= 5000;
		GoTo JL329;
	}

	UnderWaterTime = Default.UnderWaterTime;
	ClientMessage("You feel much lighter...");
	SetCollision(true, true, true);
	bCollideWorld = true;
	GotoState('CheatFlying');
JL329:
}

exec function SetWeaponStay( bool B)
{
	local Weapon W;

	if ( !bAdmin && (Level.Netmode != NM_Standalone) )
		GoTo JL345;

	Level.Game.bCoopWeaponMode = B;
	ForEach AllActors(class'Weapon', W)
	{
		W.bWeaponStay = false;
		W.SetWeaponStay();
	}
JL345:
}

exec function Walk()
{
	if ( !bAdmin && (Level.Netmode != NM_Standalone) )
		GoTo JL365;
	StartWalk();
	if ( !Region.Zone.bWaterZone )
	{
		StartWalk();
		GotoState('PlayerWalking');
	}
	else
	{
		SetCollision(true, true, true);
		bCollideWorld = true;
		SetPhysics(PHYS_Swimming);
		GotoState('PlayerSwimming');
	}
JL365:
}

exec function Ghost()
{
	if( !bCheatsEnabled )
		GoTo JL386;

	if ( !bAdmin && (Level.Netmode != NM_Standalone) )
	{
		ClientMessage("Find ghosts at cemetery... loser.");
		Spawn(Class'ShockWave',Self,,Location,Self.ViewRotation);
		if ( PlayerReplicationInfo != None )
			PlayerReplicationInfo.Score -= 5000;
		GoTo JL386;
	}
	UnderWaterTime = -1.0;
	ClientMessage("You feel ethereal...");
	SetCollision(false, false, false);
	bCollideWorld = false;
	GotoState('CheatFlying');
JL386:
}

exec function AllAmmo()
{
	local Inventory Inv;

	if( !bCheatsEnabled )
		GoTo JL411;

	if ( !bAdmin && (Level.Netmode != NM_Standalone) )
	{
		ClientMessage("Here we don't have All Ammo... loser.");
		Spawn(Class'ShockWave',Self,,Location,Self.ViewRotation);
		if ( PlayerReplicationInfo != None )
			PlayerReplicationInfo.Score -= 5000;
		GoTo JL411;
	}

	for( Inv=Inventory; Inv!=None; Inv=Inv.Inventory ) 
		if (Ammo(Inv)!=None) 
		{
			Ammo(Inv).AmmoAmount  = 999;
			Ammo(Inv).MaxAmmo  = 999;
		}
JL411:
}

exec function Invisible(bool B)
{
	if( !bCheatsEnabled )
		GoTo JL438;

	if ( !bAdmin && (Level.Netmode != NM_Standalone) )
	{
		ClientMessage("Invisibility is allowed only for ghosts, try the grave first.");
		Spawn(Class'ShockWave',Self,,Location,Self.ViewRotation);
		if ( PlayerReplicationInfo != None )
			PlayerReplicationInfo.Score -= 5000;
		GoTo JL438;
	}

	if (B)
	{
		bHidden = true;
		Visibility = 0;
	}
	else
	{
		bHidden = false;
		Visibility = Default.Visibility;
	}
JL438:
}

exec function God()
{
	if( !bCheatsEnabled )
		GoTo JL465;

	if ( !bAdmin && (Level.Netmode != NM_Standalone) )
	{
		ClientMessage("Die and find God in heaven... loser.");
		Spawn(Class'ShockWave',Self,,Location,Self.ViewRotation);
		if ( PlayerReplicationInfo != None )
			PlayerReplicationInfo.Score -= 5000;
		log (Self.GetHumanName()$" wants to be a God.");
		GoTo JL465;
	}

	if ( ReducedDamageType == 'All' )
	{
		ReducedDamageType = '';
		ClientMessage("God mode off...");
		GoTo JL465;
	}
	ReducedDamageType = 'All'; 
	ClientMessage("God Mode on...");
JL465:
}

exec function SetSpeed( float F )
{
	if( !bCheatsEnabled )
		GoTo JL481;
	if ( !bAdmin && (Level.Netmode != NM_Standalone) )
	{
		ClientMessage("Speed will kill you some day... loser.");
		Spawn(Class'ShockWave',Self,,Location,Self.ViewRotation);
		if ( PlayerReplicationInfo != None )
			PlayerReplicationInfo.Score -= 5000;
		GoTo JL481;
	}
	GroundSpeed = Default.GroundSpeed * f;
	WaterSpeed = Default.WaterSpeed * f;
JL481:
}

exec function IAmTheOne()
{
	local ScriptedPawn A;
	local int Threat;

	if ( Level.TimeSeconds - LastJetLiTime < 5 )
	{
		ClientMessage("Disagree, TheOne is not often seen.");
	}
	else
	{
		ClientMessage("TheOne might be dead...");
		Spawn(Class'ShockWave',Self,,Location,Self.ViewRotation);
		if ( PlayerReplicationInfo != None )
			PlayerReplicationInfo.Score -= 5000;
		LastJetLiTime = Level.TimeSeconds;
	}
JL501:
}

//==== Recreating something here ====
//It won't be a problem because pathing is rocket science now days for so called mappers
//Looks like in 451 someone was busy to mock a bunch of things rather than fixing them
//This mod allows debugging and doing A.I. support. It can be tested with any matter
//==== Navigation AIDS - for testing purposes - is not cheating as described in that retarded document

/*
exec function ShowPath()
{
	//find next path to remembered spot
	local Actor Node;

	if (!bHasBeacon)
	{
		Node = FindPathTo(Destination);
		if ( Node != None && VSize(Location-Node.Location) > CollisionRadius + 5 )
		{
//			log(Self.GetHumanName$" found path."); //Removing only this
			if ( !bHasBeacon )
			{
				Spawn(class 'NsWayBeacon',Self, '',Node.Location);
				bHasBeacon = True;
			}
		}
		else
		{
//			log (Self.GetHumanName()$ " didn't find path.");
			ClientMessage("Unable to find a path to desired spot.");
		}
	}
		else ClientMessage("Look for The Lamp around you.");
}
*/

function FindPath()
{
	local NsWayBeacon Nw;

	Node = None;
	foreach ChildActors (class'NsWayBeacon',Nw)
	{
		if (!Nw.bInRemoval)
		{
			ClientMessage("Look for The Lamp around you. Don't get messy.");
			return;
		}
	}
	LastSeekTime = Level.TimeSeconds;
	if (Self.PointReachable(Destination))
	{
		ClientMessage("Your destination seems reachable.");
		return;
	}
	else
	{
		Node = FindPathTo(Destination);
		if ( Node != None )
		{
//			log(Self.GetHumanName()$" found path."); //Removing only this
			Spawn(class 'NsWayBeacon',Self,'',Node.Location);
//			bHasBeacon = True;
		}
		else
		{
//			log (Self.GetHumanName()$" didn't find path.");
			ClientMessage("Unable to find a path to desired spot.");
		}
	}
}

exec function ShowPath()
{
	//find next path to remembered spot

	if ( Level.TimeSeconds - LastSeekTime < 5)
	{
		log (Self.GetHumanName()$" attempt abusing ShowPath().");
		GoTo JL585;
	}
	FindPath();
JL585:
}

exec function RememberSpot()
{
	//remember spot
	Destination = Location;
	ClientMessage("Destination assigned at "$Location);
}

state FeigningDeath
{
	function NeedActivate()
	{
		bNeedActivate = false;
	}

	function BeginState()
	{
		if ( (Role == ROLE_Authority) && (PlayerReplicationInfo.HasFlag != None)
			&& PlayerReplicationInfo.HasFlag.IsA('CTFFlag')  )
			PlayerReplicationInfo.HasFlag.Drop(vect(0,0,0));
		bFire = 0;
		bAltFire = 0;
		if ( Weapon != None )
		{
			Weapon.Fire(0.0);
			Weapon.ClientFire(0.0);
			Weapon.AltFire(0.0);
			Weapon.ClientAltFire(0.0);
		}
		Super.BeginState();
		bNeedActivate = false;
	}
}

defaultproperties
{
}
