class OSSpriteBallExplosion expands AnimSpriteEffect;

var int ExpCount;

simulated function PostBeginPlay()
{
	if ( Role == ROLE_Authority )
		MakeNoise(0.8);
	if ( Level.NetMode != NM_DedicatedServer )
		MakeSound();
	if ( !Level.bDropDetail )
		Texture = SpriteAnim[Rand(5)];
	if ( (Level.NetMode != NM_DedicatedServer) && Level.bHighDetailMode && !Level.bDropDetail ) 
		SetTimer(0.08+FRand()*0.08,False);
	else
		LightRadius = 10;
	Super.PostBeginPlay();
}

function MakeSound()
{
	PlaySound(EffectSound1,,12.0,,2200);
}

simulated Function Timer()
{
	local BlackSmoke b; 
	local vector TempVect;

	ExpCount++;
	if (FRand()<0.4)
	{
		TempVect.X = (FRand()-0.5)*80.0;
		TempVect.Y = (FRand()-0.5)*80.0;
		TempVect.Z = (FRand()-0.5)*80.0;
		if ( Level.NetMode != NM_DedicatedServer )
			Spawn(class'SpriteBallChild',Self, '', Location+TempVect);
	}
	if (FRand()<0.3)
	{
		TempVect.X = (FRand()-0.5)*60.0;
		TempVect.Y = (FRand()-0.5)*60.0;
		TempVect.Z = (FRand()-0.5)*60.0;
		if ( Level.NetMode != NM_DedicatedServer )
		{
			b = Spawn(class'BlackSmoke',Self, '', Location+TempVect);
			if ( b != None )
				b.DrawScale = FRand()*2.0+3.5;
		}
	}
	if (ExpCount<4) SetTimer(0.05+FRand()*0.05,False);
}

defaultproperties
{
     SpriteAnim(0)=Texture'UnrealShare.MainEffect.e1_a00'
     SpriteAnim(1)=Texture'UnrealShare.MainEffect.e2_a00'
     SpriteAnim(2)=Texture'UnrealShare.MainEffect.e3_a00'
     SpriteAnim(3)=Texture'UnrealShare.MainEffect.e4_a00'
     SpriteAnim(4)=Texture'UnrealShare.MainEffect.e5_a00'
     NumFrames=8
     Pause=0.080000
     EffectSound1=Sound'UnrealShare.General.Explo1'
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=0.700000
     DrawType=DT_SpriteAnimOnce
     Style=STY_Translucent
     Texture=Texture'UnrealShare.MainEffect.e1_a00'
     Skin=Texture'UnrealShare.Effects.ExplosionPal'
     DrawScale=5.500000
     LightType=LT_TexturePaletteOnce
     LightEffect=LE_NonIncidence
     LightBrightness=192
     LightHue=27
     LightSaturation=71
     bCorona=False
}