// ============================================================
//EverythingNotify
// ============================================================

class PawnNotify expands SpawnNotify;

simulated event prebeginplay() //don't check for relevance
{
}

simulated event PostBeginPlay()
{
	local actor other;
	local ScriptedPawn S;
	local string Sp;

	//Don't add to notifylist if server, but keep available, so it's existence is replicated to clients
	if (Level.NetMode == NM_DedicatedServer) //mutator works on server.
		GoTo JL66;
	Super.PostBeginPlay(); //add.
	log ("Pawn Notify Initialized");
	ForEach Allactors(class'Actor',Other)
	{
		//mask.
		if (Other.style==STY_NORMAL&&(/*other.IsA('decoration')&&((other.isa('tree')||left(getitemname(string(other.class)),5)~="plant"))||*/(other.role==role_authority&&other.isa('pawn')&&(other.isa('skaarjwarrior')||other.isa('krall')||other.isa('warlord')||other.isa('Slith')||other.isa('manta')))))
			Other.Style=Sty_masked;
		if (Other.IsA('scriptedpawn')&&!other.isa('tentacle')&&pawn(other).shadow==none)	//no decal for them.
			Scriptedpawn(Other).Shadow = Spawn(class'Monster2Shadow',other,,other.location);

		if ( Other.IsA('NavigationPoint') && Other.DrawType == Other.Class.Default.DrawType )
		{
			Other.Style = STY_Translucent;
			Other.ScaleGlow = 0.000000;
			Other.bHidden = False;
		}
		if ( Other.Class == Class 'DistanceLightning' )
		{
			Other.bAlwaysRelevant=True;
			Other.DrawType=DT_Mesh;
			Other.Mesh=LodMesh'UnrealShare.CandleM';
			Other.LightBrightness = 0;
			Other.LightHue = 0;
			Other.LightSaturation = 0;
			Other.LightRadius = 0;
			Other.LightPeriod = 0;
			Other.LightPhase = 0;
			Other.LightCone = 0;
			Other.VolumeBrightness = 0;
			Other.LightType = LT_None;
			Other.LightEffect = LE_None;
			Other.RemoteRole = ROLE_DumbProxy;
			Other.NetUpdateFrequency = 2.000000;
			Other.SetPhysics(PHYS_Falling);
		}
	}
JL66:
}

simulated event Actor SpawnNotification(Actor other)
{
	if (other.style==STY_NORMAL&&(/*other.IsA('decoration')&&((other.isa('tree')||left(getitemname(string(other.class)),5)~="plant"))||*/(other.role==role_authority&&other.isa('pawn')&&(other.isa('skaarjwarrior')||other.isa('krall')||other.isa('warlord')||other.isa('Slith')||other.isa('manta')))))
		Other.Style=Sty_masked;
	if (other.IsA('scriptedpawn')&&!other.isa('tentacle')&&pawn(other).shadow==none)	//no decal for them.
		Scriptedpawn(other).Shadow = Spawn(class'Monster2Shadow',other,,other.location);
	return other;
}
//Client Precache right now
function PreCacheReferences()
{	//never called - here to force precaching of meshes like in any normal UT game...
	//continuing mission in attempt to reduce lag as much as possible
	Spawn(Class'UnrealShare.BruteCarcass');
	Spawn(Class'UnrealShare.LesserBruteCarcass');
	Spawn(Class'UnrealShare.CowCarcass');
	Spawn(Class'UnrealShare.DevilfishCarcass');
	Spawn(Class'UnrealShare.FlyCarcass');
	Spawn(Class'UnrealI.GassiusCarcass');
	Spawn(Class'UnrealI.KrallCarcass');
	Spawn(Class'UnrealShare.MantaCarcass');
	Spawn(Class'UnrealI.MercCarcass');
	Spawn(Class'UnrealShare.NaliCarcass');
	Spawn(Class'UnrealI.PupaeCarcass');
	Spawn(Class'UnrealShare.CreatureCarcass');
	Spawn(Class'UnrealShare.SkaarjCarcass');
	Spawn(Class'UnrealI.TrooperCarcass');
	Spawn(Class'UnrealShare.SlithCarcass');
	Spawn(Class'UnrealShare.TentacleCarcass');
	Spawn(Class'MonsterHunt.RockTentacleCarcass');
	Spawn(Class'MonsterHunt.WaterTitanCarcass');
	Spawn(Class'MonsterHunt.LavaSlithCarcass');
	Spawn(Class'MonsterHunt.LavaTitanCarcass');
	Spawn(Class'UnrealI.WarlordCarcass');
	Spawn(Class'Unrealshare.CreatureChunks');
	Spawn(class'ExCreatureCarcass');
	Spawn(class'ExCreatureChunks');

	//Reinforce Defaults
	spawn(class'TMale1');
	spawn(class'TMale2');
	spawn(class'TFemale1');
	spawn(class'TFemale2');
	spawn(class'TBoss');
	spawn(class'ImpactHammer');
	spawn(class'Translocator');
	spawn(class'Enforcer');
	spawn(class'UT_Biorifle');
	spawn(class'ShockRifle');
	spawn(class'PulseGun');
	spawn(class'Ripper');
	spawn(class'Minigun2');
	spawn(class'UT_FlakCannon');
	spawn(class'UT_Eightball');
	spawn(class'SniperRifle');
	spawn(class'WarheadLauncher');
	//Now Let's see the options for old weaponry
	//These are in fact meshes used - originals
	Spawn(class'UnrealShare.ASMD');
	Spawn(class'UnrealShare.AutoMag');
	Spawn(class'UnrealShare.DispersionPistol');
	Spawn(class'UnrealShare.Eightball');
	Spawn(class'UnrealI.FlakCannon');
	Spawn(class'UnrealI.GESBioRifle');
	Spawn(class'UnrealI.Minigun');
	Spawn(class'UnrealI.QuadShot');
	Spawn(class'MH_A_V2.MHquadshot');
	Spawn(class'UnrealI.Razorjack');
	Spawn(class'UnrealI.Rifle');
	Spawn(class'UnrealShare.Stinger');
//	Spawn(class'olweapons.OLquadshot'); //End of a stupid story, LOL.
}

defaultproperties
{
}
