//================================================================================
// - UnrealTournament Enhanced Statictics - by SC]-[LONG_{HoF}
// - Additional credits to Gopostal, The_Dane, FeraliDragon and Higor. 
//================================================================================
class UTES_Mut expands Mutator config(UTES);

var bool bInitialized;
var config bool bDoubleFrag;
var int CurrentID;
var string LevelName; // current level name
var Actor IpToCountry;
//var bool bStandalone;//backup and others only needed for network-games

var UTES_HMut HUD;
var UTES_CInfo Linked;

function PreBeginPlay()
{
	local Class<ScoreBoard> UTES_SB;

	if(bInitialized)
		return;
	bInitialized=True;

	//bStandalone = (Level.NetMode == NM_Standalone);

/*	switch(Level.Game.ScoreBoardType)
	{
		Case Class'TournamentScoreBoard':
			UTES_SB = Class'UTES_DMSB';
			break;
	}

//Static linking requires UTES_SB to be preloaded anyways
//This class won't exist if it can't preload, so this code
//will never execute
/*	if (UTES_SB == None)
	{
		log("UTES: Failed to load UTES_SB!");
	}
*/
//	Level.Game.ScoreBoardType = UTES_SB;
*/
//	Level.Game.BaseMutator.AddMutator(Self);
	Level.Spawn(class'UTES_PList');
	HUD = Level.spawn(class'UTES_HMut');
}

event PostBeginPlay()
{
	//local Actor Search;
	LevelName = GetLevelName();

	foreach AllActors(class'Actor', IpToCountry)
	{
		if(string(IpToCountry.class) == "IpToCountry.LinkActor")
			break;
		else
			IpToCountry=None;
	}

	//Create ini if doesn't exist.
	SaveConfig();
	//Level.Game.DeathMessageClass = class'UTES_DMP';
	Level.Game.RegisterMessageMutator(Self);
}

event Tick( float DeltaTime)
{
//	Super.tick(DeltaTime);
	CheckForNewPlayer();
	CheckPlayerLeft();
}

//One cleanup at a time
final function CheckPlayerLeft()
{
	local UTES_CInfo Link, Kill;

	AGAIN:
	if ( Linked == none || Linked.bDeleteMe )
		return;
	if ( Linked.PlayerOwner == none || Linked.PlayerOwner.bDeleteMe )
	{
		Kill = Linked;
		if ( Linked.LinkNext != None )
			Linked = Linked.LinkNext;
		if (Kill != None)
			Kill.Destroy();
		Goto AGAIN; //This is a fast recursion
	}
	for ( Link=Linked ; Link.LinkNext!=none ; Link=Link.LinkNext )
		if (Link != None && ( Link.LinkNext.PlayerOwner == none || Link.LinkNext.PlayerOwner.bDeleteMe ) )
		{
			if (Link.LinkNext != None)
				Kill = Link.LinkNext;
			if (Kill.LinkNext != None)
				Link.LinkNext = Kill.LinkNext;
			if ( Kill != None )
				Kill.Destroy();
		}
}

//Higor: replaced
final function CheckForNewPlayer()
{
	local Pawn P;
	if(Level.Game.CurrentID <= CurrentID)
		return;
//	foreach AllActors (class'Pawn',P)
	For ( P=Level.PawnList ; P!=none ; P=P.nextPawn )
	{
		if ( P.PlayerReplicationInfo == none )
			continue;
		if ( P.PlayerReplicationInfo.PlayerID < CurrentID ) //End here, all subsequent pawns are lower ID
			break;
		InitPlayer( P);
	}
	CurrentID = Level.Game.CurrentID;
}

function InitPlayer( Pawn P)
{
	local UTES_CInfo NInfo;

	//Assert( P.PlayerReplicationInfo != none ); //Pre-release check, remove
	NInfo = P.Spawn(class'UTES_CInfo', P);
	if (NInfo != None)
	{
		NInfo.IpToCountry = IpToCountry;
		NInfo.PlayerId = P.PlayerReplicationInfo.PlayerID;
		NInfo.JoinTime = Level.TimeSeconds;
		NInfo.LinkNext = Linked;
		Linked = NInfo;
	}
}


//Higor: replaced
function UTES_CInfo FindPlayerRI(Pawn P)
{
	local UTES_CInfo Link;
	if ( P == none )
		return none;
	For ( Link=Linked ; Link!=none ; Link=Link.LinkNext )
		if ( Link.PlayerOwner == P )
			return Link;
}

function string GetLevelName()
{
	local string Str;
	local int Pos;

	Str = string(Level);
	Pos = InStr(Str, ".");
	if(Pos != -1)
		return Left(Str, Pos);
	else
		return Str;
}

function AddMutator(Mutator M)
{
	if ( M == none || M == self ) //Sanity checks... some mutators may self destruct before addition
		return; //Or attempt to add themselves twice!
	else if ( M.Class != Class )
		Super.AddMutator(M);
	else if ( M != Self )
		M.Destroy();
}
/*
function bool PreventDeath (Pawn Victim, Pawn Killer, name damageType, vector HitLocation)
{
	local UTES_CInfo RI_k, RI_v;

	if ( NextMutator != None && NextMutator.PreventDeath(Victim,Killer, damageType,HitLocation) )
		return true; //Death was prevented, do not score

	RI_k = FindPlayerRI( Killer);
	RI_v = FindPlayerRI( Victim);
	if ( RI_k == none )
		return false; //No killer info, don't do anything

	if (damageType == 'Gibbed' && Killer != None && damageType != 'RedeemerDeath')
		RI_k.Telefrags += 1;
	if ( (Killer !=none) && (Killer == Victim) ) //Logic -> killer=victim > we have victim info
		RI_v.Suicides += 1;
	if ( damageType == 'Decapitated' && Killer != Victim )
	{
		RI_k.Headshots += 1;
		if ( bDoubleFrag == True )
		{
			Killer.PlayerReplicationInfo.Score +=1;
		}
	}
	return false;
}
*/
function ModifyPlayer(Pawn Other)
{
	CheckForNewPlayer();
	Super.ModifyPlayer(Other);
}

defaultproperties
{
     bAlwaysTick=True
}
