//=============================================================================
// mhKraalBolt. Instigator, decals
//=============================================================================
class mhKraalBolt expands Projectile;
  
simulated function PostBeginPlay()
{
	if ( ScriptedPawn(Instigator) != None )
		Speed = ScriptedPawn(Instigator).ProjectileSpeed;
	Velocity = Vector(Rotation) * speed;
	if (Level.NetMode != NM_DedicatedServer)
		PlaySound(SpawnSound,SLOT_None,4.0);
	Super.PostBeginPlay();
} 

function MakeSound()
{
	MakeNoise(1.0);
}

simulated function Explode(vector HitLocation, vector HitNormal)
{
	if ( !bDeleteMe )
	{
		if ( ROLE == ROLE_Authority )
			MakeSound();
		if (Level.NetMode != NM_DedicatedServer)
		{
			PlaySound(ImpactSound, SLOT_Interact);
			Spawn(class'SmokeColumn',,,Location+Vect(0,0,38));
		}
		Destroy();
	}
}


auto state Flying
{
	simulated function ProcessTouch (Actor Other, Vector HitLocation)
	{
		local vector momentum;

		if(!bDeleteMe)
		{
			if ( Other != Instigator )
			{
				if ( Role == ROLE_Authority )
				{
					Momentum = MomentumTransfer * Normal(Velocity);
					Other.TakeDamage( Damage, instigator, HitLocation, momentum, 'zapped');
				}
				Destroy();
			}
		}
	}

Begin:
	Sleep(7.0); //self destruct after 7.0 seconds
	Explode(Location, vect(0,0,0));
}

defaultproperties
{
     ExplosionDecal=Class'mhboltskorchlong'
     speed=800.000000
     MaxSpeed=800.000000
     Damage=15.000000
     MomentumTransfer=10000
     SpawnSound=Sound'UnrealI.Krall.Krasht2'
     ImpactSound=Sound'UnrealShare.Slith.SliImpact'
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=7.500000
     Mesh=LodMesh'UnrealI.Krallbm'
     AmbientGlow=255
     bUnlit=True
     LightType=LT_Steady
     LightEffect=LE_NonIncidence
     LightBrightness=200
     LightHue=102
     LightRadius=4
}
