//=============================================================================
// mhSkaarjProjectile.
//=============================================================================
class mhSkaarjProjectile expands Projectile;

auto state Flying
{
	simulated function Timer()
	{
		Texture = Texture'Skj_a04';
	}

	simulated function ProcessTouch (Actor Other, Vector HitLocation)
	{
		local vector momentum;

		if ( !bDeleteMe )
		{
			if ( Other != Instigator )
			{
				if ( Role == ROLE_Authority )
				{
					Momentum = 10000.0 * Normal(Velocity);
					Other.TakeDamage(Damage, instigator, HitLocation, momentum, 'zapped');
				}
				Destroy();
			}
		}
	}

	function MakeSound()
	{
//		PlaySound(ImpactSound); //Nope, not here
		MakeNoise(1.0);
	}

	simulated function Explode(vector HitLocation, vector HitNormal)
	{
		local EnergyBurst e;

		if (ROLE == ROLE_Authority)
			MakeSound();
		if ( Level.NetMode != NM_DedicatedServer )
		{
			PlaySound(ImpactSound); //Sound only outta server
			e = spawn(class 'EnergyBurst',,,HitLocation+HitNormal*9);
			if (e != None)
				e.RemoteRole = ROLE_None;
		}
		Destroy();
	}

	simulated function BeginState() //SIMULATED!
	{
		if ( ScriptedPawn(Instigator) != None )
			Speed = ScriptedPawn(Instigator).ProjectileSpeed;
		Velocity = Vector(Rotation) * speed;
		if ( Level.NetMode != NM_DedicatedServer )
			PlaySound(SpawnSound);
		SetTimer(0.20,False);
	}

Begin:
	Sleep(7.0); //self destruct after 7.0 seconds
	Explode(Location, vect(0,0,0));
}

defaultproperties
{
     ExplosionDecal=Class'EnergyImpact'
     speed=800.000000
     MaxSpeed=1200.000000
     Damage=16.000000
     SpawnSound=Sound'UnrealShare.Skaarj.Skrjshot'
     ImpactSound=Sound'UnrealShare.Skaarj.SkrjImp'
     RemoteRole=ROLE_SimulatedProxy
     LifeSpan=7.300000
     DrawType=DT_Sprite
     Style=STY_Translucent
     Texture=Texture'UnrealShare.SKEffect.Skj_a00'
     DrawScale=0.700000
     bUnlit=True
     LightType=LT_Steady
     LightEffect=LE_NonIncidence
     LightBrightness=149
     LightHue=165
     LightSaturation=186
     LightRadius=4
}
