//=============================================================================
// mhscuba.
//=============================================================================
class mhscuba expands TournamentPickup;

var vector X,Y,Z;

event float BotDesireability( pawn Bot )
{
	local inventory Inv;

	for ( Inv=Bot.inventory; Inv!=None; Inv=Inv.inventory )
		if ( Inv.IsA('mhscuba') || Inv.IsA('SCUBAGear') )
			return -2; //LOL

	return Super.BotDesireability(Bot);
}

function bool HandlePickupQuery( inventory Item )
{
	local Inventory S;

	if ( item.class == class ) 
	{
		S = Pawn(Owner).FindInventoryType(class'mhscuba');
		if (  S != None )
		{
			if ( Charge > S.Charge/3)
				return True;
			else
				Charge = S.Charge;
		}
/*		else
			Charge = Clamp(S.Default.Charge - S.Charge, Charge, Item.Charge );
*/
		if (Level.Game.LocalLog != None)
			Level.Game.LocalLog.LogPickup(Item, Pawn(Owner));
		if (Level.Game.WorldLog != None)
			Level.Game.WorldLog.LogPickup(Item, Pawn(Owner));
		if ( PickupMessageClass == None )
			Pawn(Owner).ClientMessage(PickupMessage, 'Pickup');
		else
			Pawn(Owner).ReceiveLocalizedMessage( PickupMessageClass, 0, None, None, Self.Class );
		Item.PlaySound (PickupSound,,2.0);
		Item.SetReSpawn();
		return true;
	}
	if ( Inventory == None )
		return false;

	return Inventory.HandlePickupQuery(Item);
}

function inventory PrioritizeArmor( int Damage, name DamageType, vector HitLocation )
{
	if (DamageType == 'Breathe') 
	{
		if (Pawn(Owner)!=None && IsInState('activated')
			&& !Pawn(Owner).FootRegion.Zone.bPainZone) Pawn(Owner).PainTime=12;
		GotoState('Deactivated');
	}
	else if (DamageType == 'Drowned' && Damage==0) 
		GoToState('Activated');
	if (DamageType == 'Drowned')
	{
		NextArmor = None;
		Return Self;
	}
	return Super.PrioritizeArmor(Damage, DamageType, HitLocation);
}

function UsedUp()
{
	local Pawn OwnerPawn;

	OwnerPawn = Pawn(Owner);
	if ( (OwnerPawn != None) && !OwnerPawn.FootRegion.Zone.bPainZone && OwnerPawn.HeadRegion.Zone.bWaterZone )
		OwnerPawn.PainTime = 15;
	Owner.AmbientSound = None;
	Super.UsedUp();
}

state Activated
{
	function endstate()
	{

		Owner.PlaySound(DeactivateSound);
		Owner.AmbientSound = None;
		bActive = false;
	}

	function Timer()
	{
		local float LocalTime;
		local Bubble1 b;

		if ( Pawn(Owner) == None )
		{
			UsedUp();
			GoTo JL132;
		}
		Charge -= 1;
		if (Charge<-0) 
		{
			Pawn(Owner).ClientMessage(ExpireMessage);
			UsedUp();
			GoTo JL132;
		}
		LocalTime += 0.1;
		LocalTime = LocalTime - int(LocalTime);
		if ( Pawn(Owner).HeadRegion.Zone.bWaterZone && !Pawn(Owner).FootRegion.Zone.bPainZone ) 
		{
			Pawn(Owner).PainTime = 1;
			if (FRand()<LocalTime) 
			{
				GetAxes(Pawn(Owner).ViewRotation,X,Y,Z);
				b = Spawn(class'Bubble1', Owner, '', Pawn(Owner).Location
					+ 20.0 * X - (FRand()*6+5) * Y - (FRand()*6+5) * Z );
				if ( b != None )
					b.DrawScale = FRand()*0.1+0.05;
			}
			if (FRand()<LocalTime) 
			{
				GetAxes(Pawn(Owner).ViewRotation,X,Y,Z);
				b = Spawn(class'Bubble1', Owner, '', Pawn(Owner).Location
					+ 20.0 * X + (FRand()*6+5) * Y - (FRand()*6+5) * Z );
				if ( b != None )
					b.DrawScale = FRand()*0.1+0.05;
			}
		}
JL132:
	}
Begin:
	if ( Owner == None )
		GotoState('');
	SetTimer(0.1,True);
	if ( Owner.IsA('PlayerPawn') && PlayerPawn(Owner).HeadRegion.Zone.bWaterZone) 
		Owner.AmbientSound = ActivateSound;
	else 
		Owner.AmbientSound = RespawnSound;
}

state DeActivated
{
Begin:

}

defaultproperties
{
   bAutoActivate=False
   bActivatable=True
   bDisplayableInv=True
   PickupMessage="You picked up the SCUBA gear."
   ItemName="ScubaGear"
   RespawnTime=10.000000
   MaxDesireability=2.000000
   PickupViewMesh=LodMesh'UnrealShare.Scuba'
   Charge=8000
   PickupSound=Sound'UnrealShare.Pickups.GenPickSnd'
   ActivateSound=Sound'UnrealShare.Pickups.Scubal1'
   DeActivateSound=Sound'UnrealShare.Pickups.Scubada1'
   RespawnSound=Sound'UnrealShare.Pickups.Scubal2'
   Icon=Texture'UnrealShare.Icons.I_Scuba'
   Mesh=LodMesh'UnrealShare.Scuba'
   SoundRadius=16
   CollisionRadius=18.000000
   CollisionHeight=15.000000
}
