class nsgrenade expands Projectile;

var bool bCanHitOwner, bHitWater;
var float Count, SmokeRate;
var ScriptedPawn WarnTarget;	// warn this pawn away
var int NumExtraGrenades;

simulated function PostBeginPlay()
{
	local vector X,Y,Z;
	local rotator RandRot;

	Super.PostBeginPlay();
	if ( Level.NetMode != NM_DedicatedServer )
		PlayAnim('WingIn');
	SetTimer(2.5+FRand()*0.5,false);                  //Grenade begins unarmed

	if ( Role == ROLE_Authority )
	{
//		GetAxes(Instigator.ViewRotation,X,Y,Z);	
		Velocity = /*X * (Instigator.Velocity Dot X)*0.4 +*/Vector(Rotation) * (Speed +
			FRand() * 10);
		Velocity.z += 20;
		RandRot.Pitch = FRand() * 1400 - 700;
		RandRot.Yaw = FRand() * 1400 - 700;
		RandRot.Roll = FRand() * 1400 - 700;
		MaxSpeed = 10;
		Velocity = Velocity >> RandRot;
		RandSpin(50000);
		bCanHitOwner = False;
		if (Instigator != None && Instigator.HeadRegion.Zone.bWaterZone)
		{
			bHitWater = True;
			Disable('Tick');
			Velocity=0.6*Velocity;
		}
	}
}

simulated function BeginPlay()
{
	if (Level.bHighDetailMode)
	SmokeRate = 0.015;
	else
	SmokeRate = 0.1;
}

simulated function ZoneChange( Zoneinfo NewZone )
{
	local waterring w;

	if (!NewZone.bWaterZone || bHitWater) Goto JL61;
	bHitWater = True;
	if (Level.NetMode != NM_DedicatedServer)
	{
		w = Spawn(class'WaterRing',,,,rot(16384,0,0));
		w.DrawScale = 0.4;
		w.RemoteRole = ROLE_None;
	}
	Velocity=0.6*Velocity;
JL61:
}

simulated function Timer()
{
	Explosion(Location+Vect(0,0,1)*16);
}

simulated function Tick(float DeltaTime)
{
	local UT_BlackSmoke b;

	if (bHitWater) 
	{
		Disable('Tick');
		GoTo JL86;
	}
	Count += DeltaTime;
	if ( (Count>Frand()*SmokeRate+SmokeRate+NumExtraGrenades*0.03) && (Level.NetMode!=NM_DedicatedServer) ) 
	{
		b = Spawn(class'UT_BlackSmoke'); //if you could do them better who stopped you to not do this, moron ?
		if ( b != None )
			b.RemoteRole = ROLE_None;
		Count=0;
	}
JL86:
}

simulated function Landed( vector HitNormal )
{
	HitWall( HitNormal, None );
}

simulated function ProcessTouch( actor Other, vector HitLocation )
{
	if ( (Other!=instigator) || bCanHitOwner )
		Explosion(HitLocation);
}

simulated function HitWall( vector HitNormal, actor Wall )
{
	bCanHitOwner = True;
	Velocity = 0.75*(( Velocity dot HitNormal ) * HitNormal * (-2.0) + Velocity);   // Reflect off Wall w/damping
	RandSpin(100000);
	speed = VSize(Velocity);
	if ( Level.NetMode != NM_DedicatedServer )
		PlaySound(ImpactSound, SLOT_Misc, 3.5 ); //LOL
	if ( Velocity.Z > 400 )
		Velocity.Z = 0.5 * (400 + Velocity.Z);
	else if ( speed < 20 ) 
	{
		bBounce = False;
		SetPhysics(PHYS_None);
	}
}

///////////////////////////////////
function BlowUp(vector HitLocation)
{
	HurtRadius(damage, 300, MyDamageType, MomentumTransfer, HitLocation); //Again... 
	MakeNoise(1.0);
}

simulated function Explosion(vector HitLocation)
{
	local nsspriteballexplosion s;

	if (!bDeleteMe)
	{
		if (ROLE == ROLE_Authority)
			BlowUp(HitLocation);
		if ( Level.NetMode != NM_DedicatedServer )
		{
			spawn(class'Botpack.BlastMark',,,,rot(16384,0,0));
			s = spawn(class'nsspriteballexplosion',,,HitLocation);
			if (s != None)
				s.RemoteRole = ROLE_None;
		}
		Destroy();
	}
}

defaultproperties
{
   speed=1.000000
   MaxSpeed=2.000000
   Damage=200.000000
   MomentumTransfer=50000
   ImpactSound=Sound'UnrealShare.Eightball.GrenadeFloor'
   Physics=PHYS_Falling
   RemoteRole=ROLE_SimulatedProxy
   AnimSequence=WingIn
   Mesh=LodMesh'UnrealShare.GrenadeM'
   AmbientGlow=64
   bUnlit=True
   bBounce=True
   bFixedRotationDir=True
   DesiredRotation=(Pitch=12000,Yaw=5666,Roll=2334)
}